'From Squeak2.6 of 11 October 1999 [latest update: #1559] on 25 October
1999 at 6:45:20 pm'!

!ScaleMorph methodsFor: 'as yet unclassified' stamp: 'RCS 10/25/1999 18:42'!
drawOn: aCanvas
        | scale x1 y1 y2 x y3 even yy loopStart checkStart |
        super drawOn: aCanvas.
        scale _ (self innerBounds width-1) / (stop-start) asFloat.
        x1 _ self innerBounds left.
        y1 _ self innerBounds bottom - 1.
        y2 _ y1 - minorTickLength.
        loopStart _ ((start / minorTick ) ceiling) * minorTick.
        loopStart to: stop by: minorTick do:
                [:v | x _ x1 + (scale*(v - start)).
                aCanvas line: x@y1 to: x@y2 width: 1 color: Color black].
        x1 _ self innerBounds left.
        y2 _ y1 - majorTickLength.
        y3 _ y1 - (minorTickLength+majorTickLength//2).
        even _ true.

        "Make sure mjor ticks start drawing on a multiple of majorTick"
        loopStart _ ((start / majorTick ) ceiling) * majorTick.
        checkStart _ ((start / (majorTick/2.0) ) ceiling) * majorTick.
        "Check to see if semimajor tick should be drawn before majorTick"
        ( checkStart = (loopStart * 2) ) ifFalse:
                        [ loopStart _ checkStart/2.0.
                                even _ false. ].
        loopStart to: stop by: majorTick/2.0 do:
                [:v | x _ x1 + (scale*(v - start)).
                yy _ even ifTrue: [y2] ifFalse: [y3].
                aCanvas line: x@y1 to: x@yy width: 1 color: Color black.
                even _ even not].
! !


'From Squeak2.6 of 11 October 1999 [latest update: #1559] on 25 October
1999 at 6:45:14 pm'!

!ScaleMorph methodsFor: 'as yet unclassified' stamp: 'RCS 10/25/1999 18:42'!
buildLabels
        | scale x1 y1 y2 x captionMorph tickMorph loopStart |
        self removeAllMorphs.
        caption ifNotNil:
                [captionMorph _ StringMorph contents: caption.
                captionMorph align: captionMorph bounds bottomCenter
                                with: self bounds bottomCenter - (0@majorTickLength)
                                                - (0@(captionMorph height + 2)).
                self addMorph: captionMorph].
        tickPrintBlock ifNotNil:
                [scale _ (self innerBounds width-1) / (stop-start) asFloat.
                x1 _ self innerBounds left.
                y1 _ self innerBounds bottom.
                y2 _ y1 - majorTickLength.
                "Start loop on multiple of majorTick"
                loopStart _ ((start / majorTick ) ceiling) * majorTick.
                loopStart to: stop by: majorTick do:
                        [:v | x _ x1 + (scale*(v - start)).
                        tickMorph _ StringMorph contents: (tickPrintBlock value: v).
                        tickMorph align: tickMorph bounds bottomCenter
                                                with: x@y2.
                        tickMorph left < self left ifTrue:
                                [tickMorph position: self left@tickMorph top].
                        tickMorph right > self right ifTrue:
                                [tickMorph position: (self right-tickMorph width)@tickMorph top].
                        self addMorph: tickMorph]]
! !

