'From Squeak 2.1 of June 30, 1998 on 14 August 1998 at 1:08:34 pm'!
"Change Set:		ExtensionInits-di
Date:			14 August 1998
Author:			Dan Ingalls

Init morphic extensions so that boolean accessors do not need to test for nil.
This makes a substantial difference in how fast those accesses run.
A doit at the end converts all extant instances.
"!


!Morph methodsFor: 'extended access' stamp: 'di 8/14/1998 12:55'!
assureExtension

	extension == nil ifTrue: [extension _ MorphExtension new initialize]! !


!MorphExtension methodsFor: 'named access' stamp: 'di 8/14/1998 13:07'!
isPartsDonor
	^ isPartsDonor! !

!MorphExtension methodsFor: 'named access' stamp: 'di 8/14/1998 13:07'!
locked
	^ locked! !

!MorphExtension methodsFor: 'named access' stamp: 'di 8/14/1998 13:07'!
sticky
	^ sticky! !

!MorphExtension methodsFor: 'named access' stamp: 'di 8/14/1998 13:07'!
visible
	^ visible! !

!MorphExtension methodsFor: 'initialization' stamp: 'di 8/14/1998 12:55'!
initialize
	"Init all booleans to default values"
	locked _ false.
	visible _ false.
	sticky _ false.
	isPartsDonor _ false.
! !

!MorphExtension methodsFor: 'initialization' stamp: 'di 8/14/1998 13:01'!
initializeExtant
	"Init all booleans to default values"
	locked == nil ifTrue: [locked _ false].
	visible == nil ifTrue: [visible _ false].
	sticky == nil ifTrue: [sticky _ false].
	isPartsDonor == nil ifTrue: [isPartsDonor _ false].
! !


"Postscript:
Update all existing MorphExtensions.
Executable statements after this comment quote..."
MorphExtension allInstancesDo: [:e | e initializeExtant].
MorphExtension removeSelector: #initializeExtant.
!

