'From Squeak2.8alpha of 4 February 2000 [latest update: #2098] on 12 May 2000 at 6:16:31 pm'!
"Change Set:		060CancelWrite-sma
Date:			13 May 2000
Author:			Stefan Matthias Aust

You got an DNU error if you chose first 'choose another name' and then 'cancel' dor StandardFileStream class>>newFileNamed:.  Now you get the same error as for cancel."!


!StandardFileStream class methodsFor: 'file creation' stamp: 'sma 5/12/2000 10:36'!
newFileNamed: fileName
 	"Create a new file with the given name, and answer a stream opened for writing on that file. If the file already exists, ask the user what to do."

	| dir localName choice newName fullName |
	fullName _ self fullName: fileName.
	(self isAFileNamed: fullName)
		ifFalse: [^ self new open: fullName forWrite: true].

	"file already exists:"
	dir _ FileDirectory forFileName: fullName.
	localName _ FileDirectory localNameFor: fullName.
	choice _ (PopUpMenu
		labels:
'overwrite that file
choose another name
cancel')
		startUpWithCaption: localName, '
already exists.'.

	choice = 1 ifTrue: [
		dir deleteFileNamed: localName
			ifAbsent: [self error: 'Could not delete the old version of that file'].
		^ self new open: fullName forWrite: true].

	choice = 2 ifTrue: [
		newName _ FillInTheBlank request: 'Enter a new file name' initialAnswer: 'fullName'.
		newName isEmpty ifFalse: [
			fullName _ self fullName: newName.
			^ self newFileNamed: fullName]].

	self error: 'Please close this to abort file opening'! !

