'From Squeak2.9alpha of 13 June 2000 [latest update: #2411] on 18 June 2000 at 12:59:39 pm'!
"Change Set:		157AdaptingInspector-sma
Date:			18 June 2000
Author:			Stefan Matthias Aust

This change implements the speed improvements mentioned in my 'How I wasted one hour of my time' story"!

StringHolder subclass: #Inspector
	instanceVariableNames: 'object selectionIndex timeOfLastListUpdate selectionUpdateTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Inspector'!

!Inspector methodsFor: 'accessing' stamp: 'sma 6/15/2000 16:48'!
stepTimeIn: aSystemWindow
	^ (selectionUpdateTime ifNil: [0]) * 10 max: 1000! !

!Inspector methodsFor: 'selecting' stamp: 'sma 6/15/2000 16:45'!
selectionPrintString
	| text nm |
	selectionUpdateTime _ [text _ [self selection printStringLimitedTo: 5000]
		on: Error do: 
		[nm _ self selectionIndex < 3
					ifTrue: ['self']
					ifFalse: [self selectedSlotName].
		text _ ('<error in printString: evaluate "' , nm , ' printString" to debug>') asText.
		text
			addAttribute: TextColor red
			from: 1
			to: text size.
		text]] timeToRun.
	^ text! !

!Inspector methodsFor: 'selecting' stamp: 'sma 6/15/2000 16:50'!
toggleIndex: anInteger
	"The receiver has a list of variables of its inspected object. One of these 
	is selected. If anInteger is the index of this variable, then deselect it. 
	Otherwise, make the variable whose index is anInteger be the selected 
	item."

	selectionUpdateTime _ 0.
	selectionIndex = anInteger
		ifTrue: 
			["same index, turn off selection"
			selectionIndex _ 0.
			contents _ '']
		ifFalse:
			["different index, new selection"
			selectionIndex _ anInteger.
			self contentsIsString
				ifTrue: [contents _ self selection]
				ifFalse: [contents _ self selectionPrintString]].
	self changed: #selection.
	self changed: #contents.
	self changed: #selectionIndex.! !

!Inspector methodsFor: 'object fileIn' stamp: 'sma 6/18/2000 12:54'!
convertdcost0: varDict dcosts0: smartRefStrm
	"These variables are automatically stored into the new instance #('dependents' 'contents' 'object' 'selectionIndex' 'timeOfLastListUpdate').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('selectionUpdateTime')  If a non-nil value is needed, please assign it."
! !

