'From Squeak2.8 of 13 June 2000 [latest update: #2442] on 22 July 2000 at 10:35:01 pm'!

!MenuMorph methodsFor: 'control' stamp: 'tk 7/22/2000 22:33'!
invokeItem: aMenuItem event: evt
	"Perform the action associated with the given menu item."

	| sel target args selArgCount |
	aMenuItem isEnabled ifFalse: [^ self].
	lastSelection _ aMenuItem.
	"to do: report lastSelection"
	sel _ aMenuItem selector.
	target _ aMenuItem target.
	target class == HandMorph ifTrue: [(self notObsolete: aMenuItem) ifFalse: [^ self]].
	args _ aMenuItem arguments.
	selArgCount _ sel numArgs.
	Cursor normal showWhile: [  "show cursor in case item opens a new MVC window"
		selArgCount = 0
			ifTrue: [target perform: sel]
			ifFalse: [
				selArgCount = args size
					ifTrue: [target perform: sel withArguments: args]
					ifFalse: [target perform: sel withArguments: (args copyWith: evt)]]].
! !

!MenuMorph methodsFor: 'control' stamp: 'tk 7/20/2000 14:17'!
notObsolete: aMenuItem
	"Provide backward compatibility with messages being sent to the Hand.  Remove this when no projects made prior to 2.9 are likely to be used.  If this method is removed early, the worst that can happen is a notifier when invoking an item in an obsolete menu."

	(HandMorph canUnderstand: (aMenuItem selector)) ifTrue: [^ true]. 	"a modern one"

	self inform: 'This world menu is obsolete.
Please dismiss the menu and open a new one.'.
	^ false
! !

MenuMorph removeSelector: #notObsolete!
