'From Squeak2.9alpha of 17 July 2000 [latest update: #2574] on 8 September 2000 at 7:34:56 pm'!
"Change Set:		newTell
Date:			8 September 2000
Author:			Bob Arning

- updates the Tell!! button on the ProjectNavigatorMorph to use Michael Rueger's new project loader from his server. It will become more generic once we understand the options better."!


!FancyCelesteComposition methodsFor: 'as yet unclassified' stamp: 'RAA 9/8/2000 18:18'!
submit: sendNow

	| newMessageNumber personalCeleste windows |

	personalCeleste _ false.
	celeste ifNil: [
		personalCeleste _ true.
		celeste _ Celeste open.
	].

	newMessageNumber _ celeste PROTOqueueMessageWithText: (
		self breakLines: self completeTheMessage atWidth: 999
	).
	sendNow ifTrue: [celeste sendMail: {newMessageNumber}].
	personalCeleste ifTrue: [
		windows _ SystemWindow 
			windowsIn: self currentWorld 
			satisfying: [ :each | each model == celeste].
		celeste close.
		windows do: [ :each | each delete].
	].
	self forgetIt.
! !


!PasteUpMorph methodsFor: 'object fileIn' stamp: 'RAA 9/8/2000 18:03'!
convertbosfcebbpmcpbttliairfidcuww0: varDict bosfcebbpmcpbttliairfidcuwwg0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'presenter' 'model' 'cursor' 'padding' 'backgroundMorph' 'turtleTrailsForm' 'turtlePen' 'lastTurtlePositions' 'isPartsBin' 'autoLineLayout' 'indicateCursor' 'resizeToFit' 'fileName' 'isStackLike' 'dataInstances' 'currentDataInstance' 'userFrameRectangle' 'wantsMouseOverHalos' 'worldState').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('griddingOn')  If a non-nil value is needed, please assign it."
! !


!Project methodsFor: 'SuperSwiki' stamp: 'RAA 9/8/2000 19:33'!
tellAFriend: emailAddressOrNil
"
Project current tellAFriend

NOTE: the hard-coded url will go away once we have a better idea of what the server architectures wil be.
"

	self url isEmpty ifTrue: [
		^self inform: 'Since this project has not been saved yet,
I cannot tell someone where it is.'
	].
	FancyCelesteComposition new
		celeste: nil 
		to: (emailAddressOrNil ifNil: ['RECIPIENT.GOESHERE'])
		subject: 'A Squeak project link you might like'
		initialText: 'This is a link to a Squeak project: '
		theLinkToInclude: 
			'<A HREF="http://www.squeaklet.com/~sqproj/loader/localloader-js.html#',
			self versionedFileName,
			'">',
			self name,
			'</A>';

		open.
! !

