'From Squeak2.8 of 13 June 2000 [latest update: #2342] on 2 August 2000 at 8:33:41 pm'!
"Change Set:		FileContentsLabel-dew
Date:			2 August 2000
Author:			Doug Way

Fixes the window title of the FileContentsBrowser so that it reads 'File Contents Browser' rather than 'Package Browser'.  Also changes the title of the PackageBrowser to 'Package Browser' from 'Squeak Package Browser'."!


!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'dew 8/2/2000 20:02'!
browseFiles: fileList

	| package organizer packageDict browser |
	Cursor wait showWhile: [
		packageDict _ Dictionary new.
		organizer _ SystemOrganizer defaultList: Array new.
		fileList do: [:fileName |
			package _ FilePackage fromFileNamed: fileName.
			packageDict 
				at: package packageName 
				put: package.
			organizer 
				classifyAll: package classes keys 
				under: package packageName].
		(browser := self new)
			systemOrganizer: organizer;
			packages: packageDict].
	self
		openBrowserView: browser createViews
		label: 'File Contents Browser'.
! !


!PackageBrowser class methodsFor: 'instance creation' stamp: 'dew 8/2/2000 20:30'!
openBrowser
	"PackageBrowser openBrowser"

	self openBrowserView: (self new openEditString: nil)
			label: 'Package Browser'! !

