'From Squeak2.9BJ of 22 September 2000 [latest update: #2842] on 10 October 2000 at 5:22:49 pm'!
"Change Set:		UndoFix-ar
Date:			10 October 2000
Author:			Andreas Raab

A little fix for undoing a move operation which resulted in a wrong z-order."!


!Morph methodsFor: 'undo' stamp: 'ar 10/10/2000 17:21'!
undoMove: cmd redo: redo owner: formerOwner bounds: formerBounds predecessor: formerPredecessor
	"Handle undo and redo of move commands in morphic"

	self owner ifNil: [^ self beep].
	redo ifFalse:
		["undo sets up the redo state first"
		cmd redoTarget: self
			selector: #undoMove:redo:owner:bounds:predecessor:
			arguments: {cmd. true. owner. bounds. (owner morphPreceding: self)}].

	formerOwner ifNotNil:
		[formerPredecessor
			ifNil: [formerOwner addMorphFront: self]
			ifNotNil: [formerOwner addMorph: self after: formerPredecessor]].
	self bounds: formerBounds.
	(self isKindOf: SystemWindow) ifTrue: [self activate]! !

