'From Squeak2.9alpha of 13 June 2000 [latest update: #2942] on 2 November 2000 at 9:29:29 pm'!
"Change Set:		NebraskaFullScreen-ar
Date:			2 November 2000
Author:			Andreas Raab

Adds a 'fullscreen' button for nebraska clients"!


!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/2/2000 21:19'!
fixLayout
	| trans |
	trans _ self myTransformation.
	trans ifNil:[^super fixLayout].
	trans bounds: self innerBounds.

! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/2/2000 21:20'!
myWorldChanged
	| trans |
	trans _ self myTransformation.
	self layoutChanged.
	trans ifNotNil:[
		trans extentFromParent: self innerBounds extent.
		bounds _ bounds topLeft extent: trans extent + (borderWidth * 2).
	].
	self changed.
! !


!NetworkTerminalBorderMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/2/2000 21:24'!
initialize
	| button |
	super initialize.
	self setBalloonText: 'I am a view on another Squeak'.
	button _ BasicButton new label: ' 1x1 ' font: nil.
	button on: #mouseUp send: #toggleFullView to: self.
	button setBalloonText: 'Switch between 1x1 and scaled view'.
	self addMorphFront: button.! !

!NetworkTerminalBorderMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/2/2000 21:24'!
toggleFullView
	"Toggle the full view for network terminal"
	| fullExtent priorExtent |
	fullExtent _ self worldIEnclose extent + (2 * self borderWidth).
	priorExtent _ self valueOfProperty: #priorExtent.
	priorExtent ifNil:[
		self setProperty: #priorExtent toValue: self extent.
		self extent: fullExtent.
		self position: self position + self borderWidth asPoint negated.
	] ifNotNil:[
		self removeProperty: #priorExtent.
		self extent: priorExtent.
		self position: (self position max: 0@0).
	].! !


!NetworkTerminalMorph methodsFor: 'initialization' stamp: 'ar 11/2/2000 21:18'!
initialize
	super initialize.
	backgroundForm _ (
		(StringMorph contents: '......' font: (TextStyle default fontOfSize: 24))
			color: Color white
	) imageForm.
	bounds _ backgroundForm boundingBox.
! !

!NetworkTerminalMorph methodsFor: 'initialization' stamp: 'ar 11/2/2000 21:21'!
openScaled

	| window tm |
	window _ NetworkTerminalBorderMorph new
		minWidth: 100;
		minHeight: 100;
		borderWidth: 8;
		borderColor: Color orange;
		bounds: (0@0 extent: Display extent * 3 // 4).
	tm _ BOBTransformationMorph new.
	tm useRegularWarpBlt: true.		"try to reduce memory used"
	window addMorphBack: tm.
	tm addMorph: self.
	window openInWorld.
! !

NetworkTerminalBorderMorph removeSelector: #addCustomMenuItems:hand:!
NetworkTerminalBorderMorph removeSelector: #makeFullView!
