'From Squeak2.9alpha of 17 July 2000 [latest update: #2973] on 8 November 2000 at 9:56:27 am'!
"Change Set:		paintButton
Date:			8 November 2000
Author:			Bob Arning

- add a button to invoke painting from the Project Navigator"!


!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 08:47'!
addButtons

	self addARow: {
		self inAColumn: {self buttonPrev}.
		self inAColumn: {self buttonNext}.
		self inAColumn: {self buttonPublish}.
		self inAColumn: {self buttonNewer}.
		self inAColumn: {self buttonTell}.
		self inAColumn: {self buttonFind}.
		self inAColumn: {self buttonFullScreen}.
		self inAColumn: {self buttonFlaps}.
		self inAColumn: {self buttonShare}.
		self inAColumn: {self buttonPaint}.
	}.
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 09:56'!
currentNavigatorVersion

	^17		"since these guys get saved, we fix them up if they are older versions"! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 11/8/2000 09:53'!
buttonPaint

	| pb oldArgs brush myButton m |

	myButton _ self makeButton: '' balloonText: 'Make a painting' for: #doNewPainting.
	pb _ PaintBoxMorph new submorphNamed: #paint:.
	pb ifNil: [
		(brush _ Form extent: 16@16 depth: 16) fillColor: Color red
	] ifNotNil: [
		oldArgs _ pb arguments.
		brush _ oldArgs third.
		brush _ brush copy: (2@0 extent: 42@38).
		brush _ brush scaledToSize: brush extent // 2.
	].
	myButton addMorph: (m _ brush asMorph lock).
	myButton extent: m extent + (myButton borderWidth + 6).
	m position: myButton center - (m extent // 2).

	^myButton

"brush _ (ScriptingSystem formAtKey: 'Painting')."

! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 11/8/2000 09:49'!
doNewPainting

	World newDrawingFromMenu: self primaryHand lastEvent! !

