'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 5:55:56 pm'!
"Change Set:		246LinkFixe-apb
Date:			3 October 2000
Author:			Andrew P Black

The Link class method #nextLink:, which should answer a new instance of Link, instead answered nil.

The fix is the obvious addition of 'yourself'.

The one place that should have used this method -- SystemDictionary>>useUpMemory -- carefully programmed around this bug, so I changed that code so that it now uses #nextLink: in the natural way."!


!Link class methodsFor: 'instance creation' stamp: 'apb 10/3/2000 15:55'!
nextLink: aLink 
	"Answer an instance of me referring to the argument, aLink."

	^self new nextLink: aLink; yourself! !


!SystemDictionary methodsFor: 'memory space' stamp: 'apb 10/3/2000 16:40'!
useUpMemory
	"For testing the low space handler..."
	"Smalltalk installLowSpaceWatcher; useUpMemory"

	| lst |
	lst _ nil.
	[true] whileTrue: [
		lst _ Link nextLink: lst.
	].! !

