'From Squeak2.9alpha of 17 July 2000 [latest update: #3369] on 2 February 2001 at 8:33:25 am'!
"Change Set:		superSwikiDir
Date:			2 February 2001
Author:			Bob Arning

Fix walkback on some platforms when trying to expand the superSwiki in the blue directory picker list. Since the superSwiki currently has no subdirectory structure, simply remove the toggle."!

FileDirectoryWrapper subclass: #SuperSwikiDirectoryWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!

!SuperSwikiDirectoryWrapper commentStamp: 'RAA 2/2/2001 08:27' prior: 0!
The super swiki does not at present have subdirectories!


!FileList2 methodsFor: 'as yet unclassified' stamp: 'RAA 2/2/2001 08:30'!
initialDirectoryList

	| dir nameToShow |
	^ 
	((FileDirectory on: '') directoryNames collect: [ :each |
		FileDirectoryWrapper with: (FileDirectory on: each) name: each model: self
	]),
	(
		ServerDirectory serverNames collect: [ :n | 
			dir _ ServerDirectory serverNamed: n.
			nameToShow _ n.
			(dir directoryWrapperClass with: dir name: nameToShow model: self)
				balloonText: dir realUrl
		]
	)
! !


!ServerDirectory methodsFor: 'squeaklets' stamp: 'RAA 2/2/2001 08:29'!
directoryWrapperClass

	^FileDirectoryWrapper! !


!SuperSwikiDirectoryWrapper methodsFor: 'as yet unclassified' stamp: 'RAA 2/2/2001 08:28'!
contents

	^#()		"we have no sundirectories"! !

!SuperSwikiDirectoryWrapper methodsFor: 'as yet unclassified' stamp: 'RAA 2/2/2001 08:28'!
hasContents

	^false		"we have no sundirectories"! !


!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 2/2/2001 08:29'!
directoryWrapperClass

	^SuperSwikiDirectoryWrapper! !

