'From Squeak 2.2 of Sept 23, 1998 on 9 October 1998 at 4:12:52 pm'!

!Socket class methodsFor: 'instance creation' stamp: 'tk 10/9/1998 16:05'!
createIfFail: failBlock
	"Attempt to create a new socket. If successful, return the new socket. Otherwise, return the result of evaluating the given block. Socket creation can fail if the network isn't available or if there are not sufficient resources available to create another socket."

	| sock |
	sock _ super new initialize.
	sock isValid ifFalse: [^ failBlock value].
	^ sock
! !


