'From Squeak3.1alpha of 6 February 2001 [latest update: #3583] on 14 February 2001 at 9:02:43 am'!
"Change Set:		MorphSelectionFix
Date:			14 February 2001
Author:			Joshua Gargus

Fix for bug in multiple morph selection introduced in CS 3119.  To see this bug, try drag a selection in any direction other than down-right, include some morphs, and then shrink it back in the other direction.  Rather than deselecting these morphs, it bumps them towards the center of the selection area."!


!SelectionMorph methodsFor: 'geometry' stamp: 'jcg 2/14/2001 08:58'!
bounds: newBounds
	"Make sure position: gets called before extent:; Andreas' optimization for growing/shrinking in ChangeSet 3119 screwed up selection of morphs from underlying pasteup."

	selectedItems _ OrderedCollection new.  "Avoid repostioning items during super position:"
	self position: newBounds topLeft; extent: newBounds extent
! !

