'From Squeak3.1alpha of 4 February 2001 [latest update: #3587] on 15 February 2001 at 4:00:45 pm'!
"Change Set:		SetColor-tk
Date:			15 February 2001
Author:			Ted Kaehler

When a Morph's color was a fillStyle that was a color, sending color: did not actually change the Morph's color.  Fixed.  Note these rules:

1) If property #fillStyle is absent, the color inst var is the color.
2) When #fillStyle is set, color is set to (aFillStyle asColor).  Morph>>color can return this.
3) Morph>>color: will clear the #fillStyle property.

Removed the color: in PasteUpMorph, since Morph now does the same thing."!


!Morph methodsFor: 'accessing' stamp: 'tk 2/15/2001 15:55'!
color

	^ color 	"has already been set to ((self valueOfProperty: #fillStyle) asColor)"! !

!Morph methodsFor: 'accessing' stamp: 'tk 2/15/2001 15:55'!
color: aColor

	color = aColor ifFalse: [
		self removeProperty: #fillStyle.
		color _ aColor.
		self changed].
! !

PasteUpMorph removeSelector: #color:!
