'From Squeak 2.2 of Sept 23, 1998 on 23 November 1998 at 9:39:45 am'!
"Change Set:		anonymousDrop-sw
Date:			23 November 1998
Author:			Scott Wallace

Fixes a bug (when running a morphic world in an mvc project) and amends a related 'feature' (when running in a morphic project) wherein if you dropped a phrase tile from a viewer that was open for a non-flagship instance of a uniclass, you would get a puzzling error message, which, in the morphic-project case, could be irrecoverable.  The fix is just to drop the naked phrase onto the receptor rather than engage in any confusing dialogue."!


!Player methodsFor: 'scripts-kernel' stamp: 'sw 11/19/1998 12:33'!
anonymousScriptEditorFor: aPhraseTileMorph
	| aScriptEditor aUserScript |
	self isFlagshipForClass ifFalse:
		[^ aPhraseTileMorph].

	aUserScript _ self class anonymousUserScriptFor: self unusedScriptName player: self.
	aScriptEditor _ aUserScript instantiatedScriptEditor.
	aPhraseTileMorph
		ifNotNil:
			[aScriptEditor scriptName: aUserScript selector phrase: aPhraseTileMorph]
		ifNil:
			[aScriptEditor startOutEmptyForScriptName: aUserScript selector].
	^ aScriptEditor! !


