'From Squeak3.3alpha of 24 January 2002 [latest update: #4758] on 11 February 2002 at 12:09:43 pm'!
"Change Set:		FlashDupFix-ar
Date:			11 February 2002
Author:			Andreas Raab

Fixes a problem duplicating flash morphs."!


!FlashMorph methodsFor: 'events' stamp: 'ar 2/11/2002 12:08'!
duplicate
	"Usually, FlashMorphs exist in a player. 
	If they're grabbed and moved outside the player
	they should keep their position."
	| dup player |
	dup _ super duplicate.
	player _ self flashPlayer.
	dup transform: (self transformFrom: self world).
	"If extracted from player and no default AA level is set use prefs"
	(player notNil and:[self defaultAALevel == nil]) ifTrue:[
		Preferences extractFlashInHighQuality ifTrue:[dup defaultAALevel: 2].
		Preferences extractFlashInHighestQuality ifTrue:[dup defaultAALevel: 4].
	].
	^dup! !

