'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5179] on 15 April 2003 at 2:16:42 pm'!
"Change Set:		MessageTallyBlnFix-nk
Date:			31 March 2003
Author:			Ned Konz

If you have balloonHelpInMessageLists preference on, and you open a TimeProfileBrowser, and you move your mouse over the first blank line, you get a walkback.

This CS fixes that problem."!


!MessageSet class methodsFor: 'utilities' stamp: 'bkv 4/2/2003 11:33'!
parse: methodRef toClassAndSelector: csBlock
	"Decode strings of the form <className> [class] <selectorName>."

	| tuple cl |


	self flag: #mref.	"compatibility with pre-MethodReference lists"

	methodRef ifNil: [^ csBlock value: nil value: nil].
	(methodRef isKindOf: MethodReference) ifTrue: [
		^methodRef setClassAndSelectorIn: csBlock
	].
	methodRef isEmpty ifTrue: [^ csBlock value: nil value: nil].
	tuple _ methodRef asString findTokens: ' .'.
	cl _ Smalltalk atOrBelow: tuple first asSymbol ifAbsent: [^ csBlock value: nil value: nil].
	(tuple size = 2 or: [tuple size > 2 and: [(tuple at: 2) ~= 'class']])
		ifTrue: [^ csBlock value: cl value: (tuple at: 2) asSymbol]
		ifFalse: [^ csBlock value: cl class value: (tuple at: 3) asSymbol]! !

