'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5240] on 30 May 2003 at 6:17:13 pm'!
"Change Set:		browsingCodeFixes-asm
Date:			3 May 2003
Author:			Alejandro Magistrello, Tim Rowledge

1 - when you want to open a changeList browser for a file that is readOnly you a get a nil dNU: browseStream: because the file wasn't opened in write mode.

2 - if you open a code-file browser on a File that contains the definition of a non-existing class in the system and goes from the classSide to the instanceSide you'll get: PseudoMetaclass/PseudoClass dNU: #compiledMethodAt:ifAbsent:

1 is fixed by opening the file in readOnlyMode, 
2 is fixed by testing for (aClass isKindOf: PseudoClass) in FileContentsBrowser.didCodeChangeElsewhere, as one can't change code on a code-file browser just answer false
"!


!ChangeList class methodsFor: 'fileIn/Out' stamp: 'asm 5/3/2003 10:57'!
browseChangesFile: fullName
	"Browse the selected file in fileIn format."

	fullName
		ifNotNil:
			[ChangeList browseStream: (FileStream readOnlyFileNamed:  fullName)]
		ifNil:
			[self beep]! !


!FileContentsBrowser methodsFor: 'other' stamp: 'asm 5/30/2003 18:11'!
didCodeChangeElsewhere
	"Determine whether the code for the currently selected method and class has been changed somewhere else."

	| aClass |
	(aClass _ self selectedClassOrMetaClass) ifNil: [^ false].

	(aClass isKindOf: PseudoClass) ifTrue: [^ false]. "class not installed"
	^super didCodeChangeElsewhere! !

