'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 7 June 2003 at 7:53:20 pm'!
"Change Set:		KCP-0087-MovefullScreenModeToDisplayScreen
Date:			7 June 2003
Author:			stephane ducasse

move fullScreenMode: from SystemDictionary to 
DisplayScreen. (note that I identified a bug in the VM) so if you invoke this method you may crash your VM. But this is crashing your VM even when the primitive was at the old place. So the clean is safe and the VM should be fixed"!


!DisplayScreen methodsFor: 'other' stamp: 'sd 6/7/2003 19:46'!
fullScreenMode: aBoolean
	"On platforms that support it, set full-screen mode to the value of the argument. (Note: you'll need to restore the Display after calling this primitive."
	"Display fullScreenMode: true. Display newDepth: Display depth"

	<primitive: 233>
	self primitiveFailed
! !


!ScreenController methodsFor: 'menu messages' stamp: 'sd 6/7/2003 19:49'!
fullScreenOff

	Display fullScreenMode: (LastScreenModeSelected _ false).
	DisplayScreen checkForNewScreenSize.
	self restoreDisplay.
! !

!ScreenController methodsFor: 'menu messages' stamp: 'sd 6/7/2003 19:49'!
fullScreenOn

	Display fullScreenMode: (LastScreenModeSelected _ true).
	DisplayScreen checkForNewScreenSize.
	self restoreDisplay.! !


!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/7/2003 19:49'!
fullScreenMode: aBoolean
	"On platforms that support it, set full-screen mode to the value of the argument. (Note: you'll need to restore the Display after calling this primitive."
	"Smalltalk fullScreenMode: true. Display newDepth: Display depth"

	self deprecatedExplanation: 'Method deprecated>>Use DisplayScreen>>fullScreenMode:. Note that normally you should not invoke this method directly and alone but following the idiom  Display fullScreenMode: true. Display newDepth: Display depth.'
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/7/2003 19:46'!
fullScreenModeDeprecated: aBoolean
	"On platforms that support it, set full-screen mode to the value of the argument. (Note: you'll need to restore the Display after calling this primitive."
	"Smalltalk fullScreenMode: true. Display newDepth: Display depth"

	<primitive: 233>
	self primitiveFailed
! !

