'From Squeak 2.3 beta of Nov 25, 1998 on 9 January 1999 at 10:04:42 pm'!
"Change Set:		SuppressNullStruct
Date:			9 January 1999
Author:			Dan Ingalls

A simple change to prevent CodeWarrior from choking on an empty struct declaration.
"!


!CCodeGenerator methodsFor: 'C code generator' stamp: 'di 1/9/1999 22:03'!
emitCVariablesOn: aStream
	"Store the global variable declarations on the given stream."

	| i fieldName noneYet |
	aStream nextPutAll: '/*** Variables ***/'; cr.
	variables asSortedCollection do: [:var |
		(var indexOf: $.) = 0 ifTrue: [
			(variableDeclarations includesKey: var) ifTrue: [
				aStream nextPutAll: (variableDeclarations at: var), ';'; cr.
			] ifFalse: [
				"default variable declaration"
				aStream nextPutAll: 'int ', var, ';'; cr]]].
	aStream cr; cr.

	noneYet _ true.  "Suppress emtpy struct declaration altogether"
	variables asSortedCollection do: [:var |
		(i _ var indexOf: $.) > 0 ifTrue:
			[noneYet ifTrue: [aStream nextPutAll: 'struct {'; cr.
							noneYet _ false].
			fieldName _ var copyFrom: i + 1 to: var size.
			aStream tab.
			(variableDeclarations includesKey: fieldName)
				ifTrue: [aStream nextPutAll: (variableDeclarations at: fieldName), ';'; cr]
				ifFalse: ["default variable declaration"
						aStream nextPutAll: 'int ', fieldName, ';'; cr]]].
	noneYet ifFalse: [aStream nextPutAll: '} vm;'; cr; cr]. 
! !


