'From Squeak 2.3 beta of Nov 25, 1998 on 10 January 1999 at 1:47:19 pm'!
"Change Set:		BBLineFailFix
Date:			10 January 1999
Author:			Dan Ingalls

Fixes a possible stack imbalance error when primitive line drawing failed.
"!


!Interpreter methodsFor: 'I/O primitives' stamp: 'di 1/10/1999 12:54'!
primitiveDrawLoop
	"Invoke the line drawing primitive."
	| rcvr xDelta yDelta |
	rcvr _ self stackValue: 2.
	xDelta _ self stackIntegerValue: 1.
	yDelta _ self stackIntegerValue: 0.
	self success: (self loadBitBltFrom: rcvr).
	successFlag ifTrue:
		[self drawLoopX: xDelta Y: yDelta.
		self showDisplayBits].
	successFlag ifTrue:
		[self pop: 2].! !


