'From Squeak 2.3 beta of Nov 25, 1998 on 13 January 1999 at 9:11:03 am'!

!Behavior methodsFor: 'testing method dictionary' stamp: 'di 1/13/1999 09:03'!
thoroughWhichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a literal.  Dives into the compact literal notation, making it slow but thorough"
	| who |
	who _ Set new.
	methodDict keyValueDo:
		[:sel :method |
		((method hasLiteralSuchThat: [:lit | lit == literal]) or:
				[specialFlag and: [method scanFor: specialByte]])
			ifTrue:
			[((literal isMemberOf: Association) not
				or: [method sendsToSuper not
					or: [method literals allButLast includes: literal]])
				ifTrue: [who add: sel]]].
	^ who! !


!MethodDictionary methodsFor: 'enumeration' stamp: 'SqR!!!!!!!! 11/27/1998 02:14'!
keyValueDo: aBlock 
	"Faster associationsDo:. SqR!! 11/27/1998 02:14"

	| key |
	tally = 0 ifTrue: [^ self].
	1 to: self basicSize do:
		[:i | (key _ self basicAt: i) == nil ifFalse:
			[aBlock value: key value: (array at: i)]
		]! !


