'From Squeak 2.3 of January 14, 1999 on 3 February 1999 at 10:31:03 am'!
"Change Set:		VarNodeType
Date:			3 February 1999
Author:			Leandro Caniglia

Defines 'type' for VariableNodes to facilitate access for, eg, type inference.
"!


!VariableNode methodsFor: 'testing' stamp: 'di 2/3/1999 09:41'!
type
	"This code attempts to reconstruct the type from its encoding in code.
		This allows one to test, for instance, (aNode type = LdInstType)."
	| type |
	code < 0 ifTrue: [^ code negated].
	code < 256 ifFalse: [^ code // 256].
	type _ CodeBases findFirst: [:one | code < one].
	type = 0
		ifTrue: [^ 5]
		ifFalse: [^ type - 1]! !


