'From Squeak 2.3 of January 14, 1999 on 17 February 1999 at 2:25:11 pm'!
"Change Set:		slipsInChgSrtr-sw
Date:			17 February 1999
Author:			Scott Wallace

Adds check-for-slips command to the change sorter (formerly only available for the current change set, and only from the screen menu.)  

Includes the name of the affected change set and the slips-count in the message asking if user wishes to browse them."!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'sw 2/17/1999 11:13'!
lookForSlips
	| slips nameLine |
	nameLine _ '
"', self name, '"
'.
	slips _ self checkForSlips.
	slips size == 0 ifTrue:
		[^ self inform: 'No slips detected in change set', nameLine].

	(self confirm: slips size printString,
' methods in change set', nameLine, 'have halts or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?')
		ifTrue: [Smalltalk browseMessageList: slips
							name: 'Possible slips in ', name]! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 2/17/1999 11:05'!
lookForSlips
	"Open a message list browser on the new and changed methods in the current change set"

	myChangeSet lookForSlips

! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 2/17/1999 14:25'!
shiftedChangeSetMenu: aMenu
	^ aMenu labels: 
'file into new...
update
inspect change set
rename change set
check for slips
browse method conflicts
go to change set''s project
clear
more...'
		lines: #(7)
		selections: #(fileIntoNewChangeSet update  inspectChangeSet rename lookForSlips browseMethodConflicts goToChangeSetsProject clearChangeSet unshiftedYellowButtonActivity)! !


