'From Squeak 2.3 of January 14, 1999 on 3 April 1999 at 1:09:17 am'!
"Change Set:		ShiftResize
Date:			3 April 1999
Author:			Dan Ingalls

Adds shift modifier to the grow-handles, meaning equal width and height.
"!


!HaloMorph methodsFor: 'private' stamp: 'di 4/3/1999 01:07'!
doGrow: evt with: growHandle

	| newExtent |
	newExtent _ (target pointFromWorld: (evt cursorPoint - positionOffset)) - target topLeft.
	evt shiftPressed ifTrue: [newExtent _ (newExtent x max: newExtent y) asPoint].
	target extent: (newExtent max: minExtent).
	growHandle position: evt cursorPoint - (growHandle extent // 2).
	self layoutChanged.
! !

!HaloMorph methodsFor: 'private' stamp: 'di 4/3/1999 00:59'!
doScale: evt with: scaleHandle
	"Update the scale of my target if it is scalable."
	| newExtent newHandlePos |
	newHandlePos _ evt cursorPoint - (scaleHandle extent // 2).
	newExtent _ (target pointFromWorld: newHandlePos) - target center * 2.
	evt shiftPressed ifTrue: [newExtent _ (newExtent x max: newExtent y) asPoint].
	target scaleToFit: ((newExtent max: minExtent) min: Display extent).
	target scale = 1.0
		ifTrue: [scaleHandle color: Color yellow]
		ifFalse: [scaleHandle color: Color orange].
	scaleHandle position: newHandlePos.
	self layoutChanged.
! !


