'From Squeak3.1alpha of 28 February 2001 [latest update: #4244] on 12 August 2001 at 6:10:47 pm'!
"Change Set:		clipboardMorph-sw
Date:			12 July 2001
Author:			Scott Wallace

Adds simple kind of morph which always tracks the contents of the text clipboard."!

TextMorph subclass: #ClipboardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!ClipboardMorph commentStamp: 'sw 7/30/2001 23:32' prior: 0!
A morph that always displays the current contents of the text clipboard.!


!ClipboardMorph methodsFor: 'parts bin' stamp: 'sw 7/30/2001 23:31'!
initializeToStandAlone
	super initializeToStandAlone.
	self initialize.
	color _ Color blue.
	self borderWidth: 6; borderColor: (Color r: 1.0 g: 0.355 b: 0.452).
	self extent: 200 @ 100.
	self backgroundColor: (Color r: 0.484 g: 1.0 b: 0.484).
	self setBalloonText: 'This shows the current contents of the text clipboard'.
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'stepping' stamp: 'sw 6/27/2001 14:15'!
step
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'stepping' stamp: 'sw 6/27/2001 14:18'!
stepTime
	"Answer the interval between steps -- in this case a leisurely 1 seconds"

	^ 1000! !

!ClipboardMorph methodsFor: 'stepping' stamp: 'sw 6/27/2001 13:40'!
wantsSteps
	^ true! !


!ClipboardMorph class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:21'!
descriptionForPartsBin
	^ self partName:	'Clipboard'
		categories:		#('Useful')
		documentation:	'This object will always show whatever is on the text clipboard'! !
