'From Squeak3.2alpha of 2 October 2001 [latest update: #4426] on 10 October 2001 at 4:06:18 pm'!
"Change Set:		grabPhrase-sw
Date:			10 October 2001
Author:			Scott Wallace

Removes the ancient logic that tried to allow the user to extract a copy of a subphrase in classic tiles."!

!PhraseTileMorph methodsFor: 'mouse' stamp: 'sw 10/10/2001 16:06'!
mouseDown: evt 
	"Pretend we picked up the tile and then put it down for a trial   positioning. -- The essence of ScriptEditor mouseEnter:"

	| ed guyToTake dup enclosingPhrase |
	self isPartsDonor ifTrue:
		[dup _ self duplicate.
		evt hand attachMorph: dup.
		dup position: evt position.
		^ self].
	submorphs isEmpty
		ifTrue: [^ self].
	(ed _ self enclosingEditor) ifNil: [^ evt hand grabMorph: self].

	guyToTake _ self.
	[(enclosingPhrase _ guyToTake ownerThatIsA: PhraseTileMorph) notNil] whileTrue:
		[guyToTake _ enclosingPhrase].  "This logic always grabs the outermost phrase, for now anyway"
	
	"the below had comment: 'picking me out of another phrase'"
	"owner class == TilePadMorph
		ifTrue:
			[(ss _ submorphs first) class == TilePadMorph
				ifTrue: [ss _ ss submorphs first].
			guyToTake _  ss veryDeepCopy]."

	evt hand grabMorph: guyToTake.
	ed startStepping.
	ed mouseEnterDragging: evt.
	ed setProperty: #justPickedUpPhrase toValue: true.
! !

