'From Squeak3.3alpha of 24 January 2002 [latest update: #4657] on 25 January 2002 at 4:23:29 pm'!
"Change Set:		DataStreamFix-ar
Date:			25 January 2002
Author:			Andreas Raab

Fixes a problem with DataStream reading in word classes whose size differs from their basicSize."!


!ArrayedCollection methodsFor: 'objects from disk' stamp: 'ar 1/25/2002 01:46'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Reverse the byte order if the current machine is Little Endian.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."

	self class isPointers | self class isWords not ifTrue: [^ self].

	Smalltalk endianness == #little 
		ifTrue: [self swapBytesFrom: 1 to: self basicSize]
! !

