'From Squeak3.3alpha of 18 January 2002 [latest update: #4846] on 28 April 2002 at 4:30:31 pm'!
"Change Set:		eToyTranslations
Date:			28 April 2002
Authors:		Gran Hultgren, Karl Ramberg, Cees De Groot, Diego Gmez Deck and Germn Morales

Translations of the etoy vocabulary into Swedish, Norwegian, Dutch, and Spanish.  Because of evolution of the etoy vocabulary after some of these translations were made, there are several categories and several commands that lack translations in each language.  Hopefully these can be patched up over time, now that the translations are incorporated into the standard image"!


!EToyVocabulary methodsFor: 'language translations' stamp: 'CdG 4/16/2002 10:17'!
addDutchVocabulary
	"Add a Dutch etoy vocabulary

		EToyVocabulary assureTranslationsAvailableFor: #Nederlands
     "
	self translateMethodInterfaceWordings: #(

(append:					'voeg toe'				'Voegt een objekt aan deze houder toe')
(prepend:					'voeg in'				'Voegt een objekt aan het begin van deze houder toe')
(beep:						'maak geluid'  				'Maak het aangegeven geluid')
(bounce:					'stuiter weg'					'Laat het objekt van de rand wegstuiteren en speel het aangegeven geluid wanneer dit gebeurt')
(cameraPoint 				'camerastandpunt'				'Het camerastandpunt van het objekt') 
(clear 						'wis grafiek'						'Wist de huidige grafiek')
(clearOwnersPenTrails		'wis pensporen in eigenaar'	'Wist alle pennesporen in de eigenaar')
(clearTurtleTrails 			'wis pensporen' 		'Wist alle pennesporen in het object')
(color:sees: 					'kleur ziet'			'Test of de aangegeven kleur van het objekt de andere kleur kan zien')
(deleteCard 					'wis kaart'				'Wist deze kaar uit de stapel')
(doMenuItem: 				'voer menu-item uit'	'Voert het aangegeven menupunt uit')
(emptyScript 				'leeg script'				'Een leeg script')
(fire						'vuur'						'Vuurt alle acties die bij deze knop horen af')
(firstPage 					'ga naar eerste pagina'		'Ga naar eerste pagina')
(followPath					'volg pad'					'Volg het gedefineerde pad')
(forward: 					'ga vooruit met'		'Beweegt het objekt vooruit in de huidige richting')
(goToFirstCardInBackground	'ga naar eerste kaart in achtergrond'	'Gaat naar de eerste kaart in de huidige achtergrond')
(goToFirstCardOfStack		'ga naar eerste kaart op stapel'	'Gaat naar de eerste kaart op de stapel')
(goToLastCardInBackground	'ga naar laatste kaart in achtergrond'	'Gaat naar de laatste kaart in de huidige achtergrond')
(goToLastCardOfStack		'ga naar laatste kaart op stapel'		'Gaat naar de laatste kaart op de stapel')
(goToNextCardInStack		'ga naar volgende kaart op stapel'		'Gaat naar de volgende kaart op de stapel')
(goToPreviousCardInStack	'ga naar vorige kaart op stapel'	'Gaat naar de vorige kaart op de stapel')
(goToRightOf:				'plaats rechts van'		'Zet het object rechts naast een ander object neer')
(goto:						'ga naar pagina'		'Gaat naar de aangegeven pagina')
(hide					'verstop je'					'Verstopt het object')
(initiatePainting			'begin met nieuwe tekening'		'Start met een nieuwe tekening')
(insertCard				'maak kaart aan'				'Maakt een nieuwe kaart aan en voegt deze in')
(lastPage				'laatste pagina'			'Gaat naar de laatste pagina')
(liftAllPens				'pak alle pennen op'			'Pakt alle pennen op die zich in het binnenste bevinden')
(loadSineWave			'laad sinusgolf'			'Laadt een sinusgolf als de huidige grafiek')
(loadSound:				'laad geluid'					'Laadt een bepaald geluid als de huidige grafiek')
(lowerAllPens			'zet alle pennen neer'			'Zet alle pennen neer die zich in het binnenste bevinden')
(makeNewDrawingIn:	'start nieuwe tekening in'	'Begint een nieuwe tekening in het aangegeven objekt')
(moveToward:			'ga in richting '				'Beweegt het objekt in de richting van het andere objekt')
(nextPage				'ga naar volgende pagina'		'Gaat naar de volgende pagina')
(pauseScript:			'stop script'					'Stopt het uitvoeren van een script')
(play					'speel geluid af'				'Speelt de huidige grafiek als geluid af')
(previousPage			'ga naar vorige pagina' 	'Gaat naar de vorige pagina')
(removeAll				'verwijder alles'				'Verwijdert en wist alle elementen')
(reverse				'omdraaien'						'Draait de inhoud van de grafiek om')
(roundUpStrays			'haal terug'					'Haalt alle objekten terug, als ze zich ergens verstoppen')
(seesColor:				'ziet de kleur'					'Test, of het objekt de aangegeven kleur ziet')
(show					'toon jezelf'						'Toont het objekt')
(shuffleContents			'mix inhoud'					'Mixt alle objekten in een willekeurige volgorde')
(stampAndErase			'stempel en verwijder je'		'Voegt de afbeelding van het objekt aan het pennespoor toe en verwijdert het vervolgens.')
(startScript:				'start script'					'Begint met het uitvoeren van een script')
(stopScript:				'stop script'					'Stopt met het uitvoeren van een script')
(tellAllSiblings:			'zeg tegen alle broers en zussen'		'Stuurt een bericht aan alle broers/zussen van het objekt')
(touchesA:				'raakt aan'					'Test, of een objekt van het aangegeven type aangeraakt wordt')
(turn:					'draai je'				'Verandert de richting van het objekt met het aangegeven aantal graden')
(unhideHiddenObjects	'toon verstopte objekten' 		'Laat alle verstopte objekten zien')
(wearCostumeOf: 		'draag kostuum van'				'Laat het kostuum van het aangegeven objekt zien')
(wrap					'wikkel je om'				'Wikkelt het objekt om de rand van zijn houder')

(getActWhen 			'Uitvoeringsstatus'	'Bepaalt wanneer het script uitgevoerd wordt')
(getAllButFirstCharacter	'Alle tekens behalve de eerste' 'Bevat alle tekens behalve het eerste teken')
(getAmount				'grootte'					'De grootte van de afwijking ten op zichte van het centrum')
(getAngle				'hoek'					'De hoek van de afwijking ten op zichte van het centrum')
(getBorderColor			'randkleur'		'De kleur van de rand')
(getBorderWidth			'randbreedte'		'De breedte van de rand')
(getBottom 				'onderkant'					'De onderkant van het objekt')
(getBrightnessUnder		'helderheid onder'			'De helderheid onder het midden van het objekt')
(getCharacters			'tekens'					'De tekens van de inhoud')
(getColor				'kleur' 					'De kleur van het objekt')
(getColorUnder 			'kleur eronder'			'De kleur onder het midden van het objekt')
(getConePosition			'Conuspositie'			'De positie van de conus van de luidspreker')
(getCursor				'Cursor'					'De huidige tekenaanwijzing')
(getDescending			'afdalend'				'Bepaalt of de kleinste waarde eerste getoond moet worden')
(getDistance				'afstand'				'De afstand tot de oorsprong van de houder')
(getFirstCharacter		'eerste teken'		'Het eerste teken van de inhoud')
(getFirstElement			'eerste element'			'Het eerste element van de inhoud')
(getFogColor				'nevelkleur'				'De kleur van de nevel')
(getFogDensity			'neveldichtheid'			'De dichtheid van de nevel')
(getFogRangeEnd		'nevelbegin'			'De beginafstand van de nevel')
(getFogRangeStart		'neveleinde'				'De eindafstand van de nevel')
(getFogType				'nevelsoort'				'Het soort nevel')
(getGraphic				'beeld'					'De afbeelding van het objekt')
(getGraphicAtCursor		'beeld bij cursor'			'De afbeelding van het objekt bij de cursor')
(getHeading				'richting'				'De richting waar het objekt in staat')
(getHeight				'hoogte'					'De hoogte van het objekt')
(getHolder				'houder'				'De houder van het objekt')
(getIndexInOwner		'index in eigenaar' 			'De positie van het objekt in zijn eigenaar')
"@@@: Folgendes sollte vermutlich die Hand und nicht die Maus referenzieren :@@@"
(getIsUnderMouse		'is muis erover'		'Test, of de mous op het objekt staat')
"@@@: Sollte vielleicht 'Griff' heissen, aber ich mag Knubbel :-) :@@@"
(getKnobColor			'greepkleur'			'De kleur van de greep')
(getLabel				'opschrift'			'Het opschrift van het objekt')
(getLastValue			'laatste waarde'			'De laatste invoerwaarde')
(getLeft					'linkerkant'			'De linkerkant van het objekt')
(getLeftRight			'links-rechts'			'De horizontale afwijking ten opzichte van het centrum')
(getLuminanceUnder	'lichtsterkte eronder'	'De lichtsterkte onder het objekt')
(getMaxVal				'maximale waarde'			'De maximale waarde van de regelaar')
(getMinVal				'minimale waarde'			'De minimale waarde van de regelaar')
(getMouseX				'muis x-positie'		'De X koordinaat van de muispositie')
(getMouseY				'muis y-positie'		'De Y koordinaat van de muispositie')
(getNewClone			'kopieer je'			'Maakt een kopie van het objekt')
(getNumberAtCursor		'aantal bij cursor'			'Het aantal bij de cursor')
(getNumericValue		'waarde van regelaar'				'De huidige waarde van de regelaar')
(getObtrudes				'steekt uit'			'Test of het object uit zijn houder uitsteekt')
(getPenColor				'penkleur'				'De kleur van de pen')
(getPenDown			'pen neer'				'De status van de pen (op/neer)')
(getPenSize				'pengrootte'			'De doorsnede van de pen')
(getRight				'rechterkant'			'De rechterkant van het objekt')
(getRoundedCorners		'afgeronde hoeken'			'Test of hoeken afgerond moeten worden')
(getSampleAtCursor		'steekproef'				'Een steekproef van de waarde bij de cursor')
(getSaturationUnder		'verzadiging eronder'	'De verzadiging van de kleur onder het objekt')
(getScaleFactor			'schalingsfaktor'		'De schalingsfaktor van het objekt')
(getTheta				'theta'					'De hoek met de X-as')
(getTop					'bovenkant'			'De bovenkant van het objekt')
(getTruncate			'afronden'				'Bepaalt of slechts gehele getallen gebruikt worden')
(getUpDown				'erboven-onder'			'De verticale afwijking ten opzichte van het centrum')
(getValueAtCursor		'objekt bij cursor'		'Het objekt bij de huidige cursorpositie')
(getViewingByIcon 		'symboolweergave'		'Bepaalt of het objekt met zijn symbool moet worden weergegeven')
(getX					'x'						'De X koordinaat van het objekt')
(getY					'y'						'De Y koordinaat van het objekt')
(getWidth				'breedte'					'De breedte van het objekt')) language: #Nederlands.


	self translateCategories: #(
(basic					Simpel					'Standaardzicht')
(#'book navigation'		#'Boeknavigatie'		'Navigatie in boeken')
(button					Knop					'Het objekt als knop')
(collections				Houder				'Het objekt als houder')
(fog					Nevel					'3D Nevel eigenschappen')
(geometry				Geometrie				'Over de geometrief van het objekt')
(#'color & border'		#'Kleur & Rand'			'Over kleuren en randen')
(graphics				Grafisch					'Grafische eigenschappen')
(#'instance variables'	Variabelen				'Variabelen van het objekt')
(joystick				Joystick					'Het objekt als joystick')
(miscellaneous			Overige			'Alles dat nergens anders bij past')
(motion					Beweging				'Bewegingseigenschappen')
(paintbox				Tekenpalet				'Het tekenpalet')
(#'pen trails'			Pennesporen				'Alles over het achterlaten van pennesporen')
(#'pen use'				Pengebruik					'Het gebruik van pennen')
(playfield				Speelveld				'Het speelveld')
(sampling				Meten					'Het meten van waarden')
(scripts					Scripts					'Al je scripts')
(slider					Regelaar					'Het objekt als regelaar')
(speaker				Luidspreker			'Het objekt als luidspreker')
(#'stack navigation'		Stapelnavigatie		'Navigatie in stapels')
(storyboard				Storyboard				'Storyboard')
(tests					Tests					'Verscheidene tests')
(text					Tekst						'Het objekt als tekst')
(viewing				Observatie				'Zoals je het objekt ziet')
(vector					Vector					'Het objekt als vector')
 ) language: #Nederlands "nou ja, nederlands... ;-) - CdG"
! !

!EToyVocabulary methodsFor: 'language translations' stamp: 'kfr 12/29/2001 16:20'!
addNorwegianVocabulary
	"Add a Norwegian vocabulary. "

	self translateMethodInterfaceWordings: #(
(append: 'legg til' 'Legg til objektet i mitt innehold')
(beep: 'spill lyd' 'Spill denne lyden')
(bounce: 'sprett' 'sprett bort fra kanten om den treffes')
(cameraPoint 'kameraposisjon' 'kamerans posisjon')
(clear 'rens' 'Rens bort bildet')
(clearOwnersPenTrails 'rens alla pennestrk' 'Rens bort alle pennestrk i pennens lekeplass')
(clearTurtleTrails 'rens skilpaddestrk' 'Rens bort alle skilpaddestrk p innsiden')
(color:sees: 'farge syns' 'Om valgte farge ser angitt farge')
(deleteCard 'Ta bort kort' 'Ta bort dette kortet')
(doMenuItem: 'utfr menyvalg' 'utfr menyvalget')
(doScript: 'kjr' 'kjr skriptet en gang, ved nesta tick')
(emptyScript 'tomt skript' 'et tomt skript')
(fire 'starta' 'starter alle knapphendelser for dette objektet')
(firstPage 'frsta siden' 'g till frsta siden')
(followPath 'flg vei' 'flg denne veien')
(forward: 'framover med' 'Flytter objektet framover i objektets nvrende rettning')
(getActWhen 'kjr nr' 'Nr skriptet skal kjres')
(getAllButFirstCharacter 'alle uten om frsta' 'Alle mine tegn uten om det frste')
(getAmount 'strrelse' 'Forflyttningens strrelse')
(getAngle 'vinkel' 'Vinkelforflyttningens strrelse')
(getBorderColor 'kantfarge' 'Fargen p objektets kant')
(getBorderWidth 'kantbredde' 'Bredden p objektets kant')
(getBottom 'bunn' 'Den nederste kanten')
(getBrightnessUnder 'kontrast' 'Kontrasten under objektets mittpunkt')
(getCharacters 'tegn' 'Tegnet i mitt innehold')
(getColor 'farge' 'Objektets farge')
(getColorUnder 'farge under' 'Fargen under objektets mittpunkt')
(getConePosition 'hytalerposition' 'hytalerens position')
(getCursor 'markr' 'Markrens nvrende position, ombytt til frste om det er mulig')
(getDescending 'fallende' 'Sier om den minste verdien er verst / til venstre (fallende = false) eller nederst / til hyre (fallande = true)')
(getDistance 'avstand' 'Lengden p vektoren mellom utgangspunktet og objektets posisjon')
(getFirstCharacter 'frste tegnet' 'Det frste tegnet i mitt innehold')
(getFirstElement 'frsta elementet' 'Det frsta objektet i mitt innehold')
(getFogColor 'tkens farge' 'Fargen p tken som benyttes')
(getFogDensity 'tkens tetthet' 'Tettheten p tken som benyttes')
(getFogRangeEnd 'tkens intervalslutt' 'Intervalets slutt p tken som benyttes')
(getFogRangeStart 'tkens intervalstart' 'Intervalets start p tken som benyttes')
(getFogType 'tkens typ' 'Typen av tke som benyttes')
(getGraphic 'bilde' 'Bildet som bres av objektet')
(getGraphicAtCursor 'bilde ved markr' 'Bildet som bres av objektet ved markren')
(getHeading 'rettning' 'I vilken rettning objektet peker. 0 er rett opp')
(getHeight 'hyde' 'Hyden')
(getHolder 'beholder' 'objektets beholder')
(getIndexInOwner 'elementnummer' 'mitt indeksnummer i min beholdere')
(getIsUnderMouse 'er under muspekeren' 'om objektet befinner seg under muspekeren')
(getKnobColor 'hndtakets farge' 'Hndtakets farge')
(getLabel 'etikett' 'Teksten p knappen')
(getLastValue 'seneste verdi' 'Seneste beregnede verdi')
(getLeft 'venstre' 'Den venstre kanten')
(getLeftRight 'venstre/hyre' 'Horisontel forflyttning')
(getLuminanceUnder 'lysstyrke under' 'Lysstyrken under objektets mittpunkt')
(getMaxVal 'maxverdi' 'Tallet som representerer nr hndtaket er lengst til hyre eller lengst ned, den strste verdien som hndtaket gir.')
(getMinVal 'minverdi' 'Tallet som representerer nr hndtaket er lengst til venstre eller hyest opp, den minste verdien som hndtaket gir.')
(getMouseX 'mus x' 'Muspekerens x-koordinat')
(getMouseY 'mus y' 'Muspekerens y-koordinat')
(getNewClone 'kopia' 'returnerer en kopi av det her objektet')
(getNumberAtCursor 'tall ved markr' 'tallet ved markren')
(getNumericValue 'numeriskt verdi' 'Et tall som representerer den aktuelle posisjonen av hndtaket.')
(getObtrudes 'stikker ut' 'om objektet stikker ut over beholderens kant')
(getPenColor 'pennefarge' 'fargen p blekket i pennen')
(getPenDown 'pen nedtrykt' 'om pennen er nedtrykt n')
(getPenSize 'pennens bredde' 'pennens bredde')
(getRight 'hyre' 'Den hyre kanten')
(getRoundedCorners 'rundede hjrner' 'om hjrnene skal vre runde')
(getSampleAtCursor 'verdi ved markr' 'Nvrende verdi ved markrens posisjon')
(getSaturationUnder 'mettning under' 'Fargemettning under objektets mittpunkt')
(getScaleFactor 'skala' 'Objektets skala')
(getTheta 'theta' 'Vinkelen mellom den positive x-axelen og vektoren mellom utgangspunktet og objektets posisjon')
(getTop 'toppen' 'Den verste kanten')
(getTruncate 'heltall' 'Om bare heltall anvendes som verdi, om brktal ikke er tillatt.')
(getUpDown 'opp/ner' 'Vertikal forflyttning')
(getValueAtCursor 'spiller ved markr' 'objektet ved markren')
(getViewingByIcon 'normalt synssett' 'Synsettet p inneholdet er normal')
(getWidth 'bredd' 'Bredden')
(getX 'x' 'X-koordinaten')
(getY 'y' 'Y-koordinaten')
(goToFirstCardInBackground 'g til frste i bakgrunnen' 'G til det frste kortet i den nvrende bakgrunnen')
(goToFirstCardOfStack 'g til frste kortet i stacken' 'G til frste korten i hele stacken')
(goToLastCardInBackground 'g til siste kortet i bakgrunnen' 'G til det siste kortet i den nvrende bakgrunnen')
(goToLastCardOfStack 'g til siste kortet i stacken' 'G til det siste kortet i hele stacken')
(goToNextCardInStack 'g till neste kort' 'G til neste kort i stacken')
(goToPreviousCardInStack 'g til forrige kort' 'G til det forrige kortet i stacken')
(goToRightOf: 'plassere etter' 'plassere dette objekt til hyre om et annet')
(goto: 'g til' 'g til angitt side')
(hide 'gjem' 'gjr objektet usynligt')
(initiatePainting 'begynn malning' 'Begynn malning av et nytt objekt i den vanlige lekeplatsen.')
(insertCard 'legg inn kort' 'Skap et nytt kort')
(lastPage 'siste siden' 'g til siste siden')
(liftAllPens 'lft alle penner' 'Lft pennene p mitt inneholds alle objekt.')
(loadSineWave 'pne sinusblge' 'pne en sinusblge som nvrende graf')
(loadSound: 'pne lyd' 'pne angivet lyd som nvrende lyd')
(lowerAllPens 'senk alle penner' 'Senk pennene p mitt inneholds alle objekt.')
(makeNewDrawingIn: 'bgynn malning i' 'lag en ny malning i angiven lekeplats')
(moveToward: 'flytte mot' 'flytte mot angivet objekt')
(nextPage 'nesta side' 'g til neste side')
(pauseAll: 'pause alle' 'pause skriptet i objektet och alle dets slekninger')
(pauseScript: 'pause skript' 'pause skriptet')
(play 'spela' 'Spill nvrende graf som en lyd')
(previousPage 'foregende side' 'g til foregende side')
(removeAll 'ta bort alle' 'Ta bort alle element fra lekeplatsen')
(reverse 'reversere' 'Reversere grafen')
(roundUpStrays 'samle inn bortsprungne' 'Samle inn alle deler utenfor beholderen s at de blir synlige igen.')
(seesColor: 'er over farge' 'om noen del av objektet er over den angitte fargen')
(show 'vise' 'gjr objektet synlig')
(shuffleContents 'blande innehold' 'Blande lekeplatsens innehold')
(stampAndErase 'stemple og forsvinn' 'legg til mitt bilde som tegnestrek och forsvinn')
(startAll: 'start alle' 'start skriptet tickende i objektet och alla dets slekninger.')
(startScript: 'start skript' 'start skriptet tickende')
(stopAll: 'stopp alle' 'gjr skriptet "normalt" i objektet och alla dets slektninger')
(stopScript: 'stopp skript' 'gjr skriptet "normalt" i objektet')
(tellAllSiblings: 'si til slekninger' 'send et meddelende til alla slekninger')
(touchesA: 'rrer' 'Om jeg rrer noe som ser ut som...')
(turn: 'sving med' 'Endre objektets retning med angitt mengde')
(unhideHiddenObjects 'vise alle gjemte objekt' 'Gjr alle gjemte objekt synlige.')
(wearCostumeOf: 'se ut som' 'br samme drakt som...')
(wrap 'fold over kant' 'fold over kanten om det er passende')) language: #Norsk.

	self translateCategories: #(
(basic					'elementre'				'et antall viktige saker')
(#'book navigation'		'boknavigering'			'saker som har med bker och stackar  gjre')
(button					'knapp'					'objektet betraktet som en knapp man kan trykke p')
(collections				'samlinger'				'objektet betraktet som en samling av andre objekt')
(fog					'tke'					'3-dimensionell tke')
(geometry				'geometri' 				'verdier og koordinater')
(#'color & border'		'farger & kanter'		'saker som har med farger og kanter p objekt  gjre')
(graphics				'grafikk'					'objektet betraktat som et bilde')
(#'instance variables'	'instansvariabler'		'instansvariabler tilhrende dette objektet')
(joystick				'joystick	'				'objektet som en joystick')
(miscellaneous			'diverse' 				'diverse kommander')
(motion					'rrelse' 				'saker som har med forflyttning och vridning  gjre')
(paintbox				'maleskrin'				'malepaletten')
(#'pen trails'			'pennestrk'				'saker som har med strk som pennen tegner  gjre)
(#'pen use'				'pen bruk' 		'bruk av et objekts pen')
(playfield				'lekeplats'					'objektet som beholdere for andre synlige objekt')
(sampling				'prvetagning'			'prvetagning')
(scripts					'skript'					'metoder lagt til dette objektet')
(slider					'hndtak'			'nyttige funksjoner for hndtak')
(speaker				'hytaler'				'objektet sett som en hytaler')
(#'stack navigation'		'stacknavigering'		'navigering innen en stack')
(storyboard				'storyboard'				'storyboard')
(tests					'tester'					'for  lage ja/nei tester i script')
(text					'tekst'					'Objektet som tekst')
(viewing				'seer'					'Saker som har med olika seeren  gjre')
(vector					'vektor'					'Objektet som en vektor')
 ) language: #Norsk.

	self addToTranslationTableFrom: #(
(:						'_'						'gi verdi')
(Incr:					'ke med'			'ka verdi med')
(Decr:					'minske med'			'minske verdi med')
(Mult:					'multiplicera med'			'multiplisere verdi med'')) language: #Norsk! !

!EToyVocabulary methodsFor: 'language translations' stamp: 'sw 4/28/2002 16:23'!
addSpanishVocabulary

   "'Espaol' translation by Diego Gmez Deck and Germn Morales"
   "        "

   self translateMethodInterfaceWordings: #(
(append:                   'agregar al final'                    'Agregar el objeto a mi contenido, ponindolo despus de todos los otros objetos actualmente contenidos por mi')
(beep:                     'sonar'                               'Reproducir el sonido especificado')
(bounce:                   'rebotar'                             'Rebotar si toca el borde')
(cameraPoint               'punto de la cmara'                  'El punto de la cmara')
(clear                     'limpiar'                             'Limpia el grfico del contenido actual')
(clearOwnersPenTrails      'limpiar todos los rastros del lpiz'       'Limpiar todos los rastros del lpiz en mi contenedor')
(clearTurtleTrails         'limpiar los rastros del lpiz'       'Limpiar los rastros del lpiz en el interior')
(color:sees:               'color ve'                            'Si el color dado ve el otro color')
(deleteCard                'borrar tarjeta'                      'Borrar la tarjeta actual')
(doMenuItem:               'realizar la opcin del men'         'Realizar la opcin del men')
(doScript:                 'realizar'                            'Realizar el guin dado una vez, en el prximo instante')
(emptyScript               'guin vaco'                         'Un guin vaco')
(fire                      'activar'                             'Activar todas y cada una de las acciones del botn de este objeto')
(firstPage                 'primera pgina'                      'Ir a la primera pgina')
(followPath                'seguir el camino'                    'Seguir el camino')
(forward:                  'avanzar'                             'Mover el objeto hacia adelante en la direccin del objeto')
(getActWhen                'activar cuando'                      'Cuando se debe activar el guin')
(getAllButFirstCharacter   'todos excepto el primero'            'Todos mis caracteres excepto el primero')
(getAmount                 'desplazamiento'                      'La cantidad de desplazamiento')
(getAngle                  'ngulo'                              'El desplazamiento angular')
(getBorderColor            'color del borde'                     'El color del borde del objeto')
(getBorderWidth            'ancho del borde'                     'El ancho del borde del objeto')
(getBottom                 'abajo'                               'El borde de abajo')
(getBrightnessUnder        'brillo debajo'                       'El brillo debajo del centro del objeto')
(getCharacters             'caracteres'                          'Los caracteres en mi contenido')
(getColor                  'color'                               'El color del objeto')
(getColorUnder             'color debajo'                        'El color debajo del centro del objeto')
(getConePosition           'posicin del cono'                   'La posicin del cono del altavoz')
(getCursor                 'cursor'                              'La posicin actual del cursor, trasladado al principio si es apropiado')
(getDescending             'descendiente'                        'Verdadero si el menor valor est arriba o a la izquierda, falso si est abajo o a la derecha')
(getDistance               'distancia'                           'El largo del vector que conecta el origen a la posicin del objeto')
(getFirstCharacter         'primer caracter'                     'El primer caracter de mi contenido')
(getFirstElement           'primer elemento'                     'El primer objeto de mi contenido')
(getFogColor               'color de la niebla'                  'El color de la niebla que se est aplicando')
(getFogDensity             'intensidad de la niebla'             'La intensidad de la niebla que se est aplicando')
(getFogRangeEnd            'niebla hasta'                        'Hasta donde se aplica la niebla')
(getFogRangeStart          'niebla desde'                        'Desde donde se aplica la niebla')
(getFogType                'tipo de niebla'                      'El tipo de la niebla que se est aplicando')
(getGraphic                'grfico'                             'El grfico usado actualmente')
(getGraphicAtCursor        'grfico en el cursor'                'El grfico usado por el objeto en el cursor')
(getHeading                'direccin'                           'En que direccin est mirando el objeto. Cero significa hacia arriba')
(getHeight                 'altura'                              'La altura del objeto')
(getHolder                 'contenedor'                          'El contenedor del objeto')
(getIndexInOwner           'nmero de elemento'                     'Mi nmero dentro de mi contenedor')
(getIsUnderMouse           'debajo del ratn'                    'Si el objeto est debajo de la posicin actual del ratn')
(getKnobColor              'color de la perilla'                 'El color del deslizador')
(getLabel                  'etiqueta'                            'La etiqueta del botn')
(getLastValue              'ltimo valor'                        'El ltimo valor obtenido')
(getLeft                   'izquierda'                           'El borde de la izquierda')
(getLeftRight              'desplazamiento izquierda - derecha'  'El desplazamiento horizontal')
(getLuminanceUnder         'luminiscencia debajo'                'La luminiscencia debajo del centro del objeto')
(getMaxVal                 'mximo valor'                        'El nmero representado cuando la perilla est a la derecha o abajo del deslizador. Este es el mximo valor devuelto por el deslizador')
(getMinVal                 'mnimo valor'                        'El nmero representado cuando la perilla est a la izquierda o arriba  del deslizador. Este es el mnimo valor devuelto por el deslizador')
(getMouseX                 'x del ratn'                         'La coordenada X del puntero del ratn')
(getMouseY                 'y del ratn'                         'La coordenada Y del puntero del ratn')
(getNewClone               'copiar'                              'Devuelve una copia de este objeto')
(getNumberAtCursor         'nmero en el cursor'                 'El nmero en el cursor')
(getNumericValue           'valor numrico'                      'Un nmero representando la posicin actual de la perilla')
(getObtrudes               'sobresale'                         'Si el objeto sobresale de los bordes de su contenedor')
(getPenColor               'color del lpiz'                     'El color del lpiz')
(getPenDown                'lpiz bajo'                          'Si el lpiz est bajo')
(getPenSize                'tamao del lpiz'                    'El ancho del lpiz')
(getRight                  'derecha'                             'El borde derecho')
(getRoundedCorners         'esquinas redondeadas'                'Si las esquinas deberan ser redondeadas')
(getSampleAtCursor         'muestra en el cursor'                'El valor de la muestra en la posicin actual del cursor')
(getSaturationUnder        'saturacin debajo'                   'La saturacin debajo del centro del objeto')
(getScaleFactor            'factor de escala'                    'El factor de escala por el cual el objeto es magnificado')
(getTheta                  'theta'                               'El ngulo entre el eje X positivo y el vector que conecta el origen a la posicin del objeto')
(getTop                    'arriba'                              'El borde de arriba')
(getTruncate               'truncado'                            'Si es verdadero, solo nmeros son usados como valores; si es falso, valores fraccionarios son permitidos')
(getUpDown                 'desplazamiento arriba - abajo'       'El desplazamiento vertical')
(getValueAtCursor          'objeto en el cursor'                 'El objeto actualmente en el cursor')
(getViewingByIcon          'vista normal'                        'Si los contenidos son vistos normalmente')
(getWidth                  'ancho'                               'El ancho')
(getX                      'x'                                   'La coordenada X')
(getY                      'y'                                   'La coordenada Y')
(goToFirstCardInBackground 'ir a la primera tarjeta del fondo'   'Ir a la primera tarjeta del fondo actual')
(goToFirstCardOfStack      'ir a la primera tarjeta de la pila'  'Ir a la primera tarjeta de la pila completa')
(goToLastCardInBackground  'ir a la ltima tarjeta del fondo'    'Ir a la ltima tarjeta del fondo actual')
(goToLastCardOfStack       'ir a la ltima tarjeta de la pila'   'Ir a la ltima tarjeta de la pila completa')
(goToNextCardInStack       'ir a la prxima tarjeta de la pila'  'Ir a la prxima tarjeta')
(goToPreviousCardInStack   'ir a la anterior tarjeta de la pila' 'Ir a la anterior tarjeta')
(goToRightOf:              'alinear despus de'                     'Ubicar este objeto a la derecha de otro')
(goto:                     'ir a'                                'Ir a la pgina dada')
(hide                      'ocultar'                             'Hacer invisible al objeto')
(include:                  'incluir'                             'Agregar el objeto a mi contenido')
(initiatePainting          'iniciar pintado'                     'Iniciar el pintado de nuevos objetos en el campo de juegos estandar')
(insertCard                'insertar nueva tarjeta'              'Insertar una nueva tarjeta')
(lastPage                  'ltima pgina'                       'Ir a la ltima pgina')
(liftAllPens               'levantar todos los lpices'          'Levantar los lpices de todos los objetos en mi interior')
(loadSineWave              'cargar forma de onda senoidal'       'Cargar una forma de onda senoidal como el grfico actual')
(loadSound:                'cargar sonido'                       'Cargar el sonido especificado dentro del grfico actual')
(lowerAllPens              'bajar todos los lpices'             'Bajar los lpices de todos los objetos en mi interior')
(makeNewDrawingIn:         'empezar pintado en'                  'Crear un nuevo dibujo en el campo de juegos especificado')
(moveToward:               'mover hacia'                         'Mover hacia el objeto dado')
(nextPage                  'prxima pgina'                      'Ir a la prxima pgina')
(pauseAll:                 'pausar todo'                         'Hacer que todos los guiones se pausen en el objeto y en todos sus hermanos')
(pauseScript:              'pausar guin'                        'Hacer que se pause el guin dado')
(play                      'reproducir'                          'Reproducir el grfico actual como un sonido')
(prepend:                  'agregar adelante'                    'Agregar el objeto a mi contenido, ponindolo antes que todos los otros objetos actualmente contenidos por mi')
(previousPage              'pgina anterior'                     'Ir a la pgina anterior')
(removeAll                 'remover todo'                        'Remover todos los elementos del campo de juegos')
(reverse                   'invertir'                            'Invertir el grfico')
(roundUpStrays             'reunir perdidos'                       'Traer todas las partes fuera del contenedor nuevamente a la vista')
(seesColor:                'sobre color'                         'Si alguna parte del objeto esta sobre el color dado')
(show                      'mostrar'                             'Hacer visible el objeto')
(shuffleContents           'mezclar el contenido'                'Mezclar el contenido del campo de juegos')
(stampAndErase             'estampar y borrar'                   'Estampar mi imagen al rastro del lpiz y salir')
(startAll:                 'comenzar todo'                       'Comenzar el latido del guin en el objeto y en todos sus hermanos')
(startScript:              'comenzar guin'                      'Comenzar el latido del guin dado')
(stopAll:                  'parar todos'                         'Hacer que el estado del guin dado sea "normal" en el objeto y en todos sus hermanos')
(stopScript:               'detener guin'                         'Hacer que el estado del guin dado sea "normal"')
(tellAllSiblings:          'decir a todos los hermanos'          'Enviar un mensaje a todos los hermanos')
(touchesA:                 'toca un'                             'Si toco algo que parece como...')
(turn:                     'girar'                               'Cambiar la direccin del objeto en la cantidad especificada')
(unhideHiddenObjects       'mostrar objetos ocultos'             'Mostrar todos los objetos ocultos')
(wearCostumeOf:            'lucir como'                          'Usar el traje de...')

(wrap                      'ajusta'                                'traslada al otro borde si es apropiado')
(penArrowheads             'puntas de flecha en el lpiz'        'Si muestra puntas de flecha al final de cada trazo del lpiz')
(dropShadow                'sombra'                              'Si muestra la sombra')
(shadowColor               'color de la sombra'                  'Color de la sombra')
(clipSubmorphs             'cortar submorphs'                    'Si cortar o no mis submorphs')

) language: #'Espaol'.

   self translateCategories: #(
(basic                 'bsico'                 'Unas pocas cosas importantes')
(#'book navigation'    'navegacion del libro'   'Relativo a libros, pilas, etc.')
(button                'botn'                  'Para pensar este objeto como un botn')
(collections           'colecciones'            'Para pensar este objeto como una coleccin')
(fog                   'niebla'                 'Niebla 3D')
(geometry              'geometra'              'Medidas y coordenadas')
(#'color & border'     'color y borde'          'Asuntos relacionados con colores y bordes de objetos')
(graphics              'grficos'               'Para pensar este objeto como una imagen')
(#'instance variables' 'variables de instancia' 'Variables de instancia agregadas por este objeto')
(joystick              'joystick'               'El objeto como un Joystick')
(miscellaneous         'miscelneo'             'Comandos varios')
(scripting             'guiones'                'Comandos para  comenzar y parar guiones, etc.')
(motion                'movimiento'             'Asuntos relacionados con el movimiento y el giro')
(paintbox              'paleta de pintor'       'La paleta del pintor')
(#'pen trails'         'rastros del lpiz'      'Relacionados a los rastros dejados por los lpices')
(#'pen use'            'uso del lpiz'          'Uso del lpiz del objeto')
(playfield             'campo de juegos'        'El objeto como un contenedor para otros objetos visibles')
(sampling              'muestreo'               'Muestreo')
(scripts               'guiones'                'Guiones agregados por este objeto')
(slider                'deslizador'             'Funciones tiles para deslizadores')
(speaker               'altavoz'                'El objeto como un altavoz de audio')
(#'stack navigation'   'navegacin de pila'     'Navegacin dentro de una pila')
(storyboard            'pizarra de historia'    'Pizarra de historia')
(tests                 'pruebas'                'Pruebas por verdadero/falso, para usar en cuadros de "Prueba" de guiones')
(text                  'texto'                  'El objeto como texto')
(viewing               'visualizacin'          'Asuntos relacionados a visualizacin')
(vector                'vector'                 'El objeto como un vector')
(layout                'disposicin'            'Disposicin de los objetos contenidos')
(#'drag & drop'        'arrastrar y soltar'     'Arrastrar y soltar')
(observation           'observacin'            'Observacin')

 ) language: #'Espaol'.

        self addToTranslationTableFrom: #(
(:                                                '_'                                                'asignar el valor')
(Incr: 'incrementar por' 'incrementar el valor por')
(Decr: 'reducir por' 'reducir el valor por')
(Mult: 'multiplicar por' 'multiplicar el valor por')) language: #'Espaol'
! !

!EToyVocabulary methodsFor: 'language translations' stamp: 'gh 9/27/2001 16:32'!
addSwedishVocabulary
	"Add a Swedish vocabulary. Well, ok, perhaps better translations could be made...
	I might have simplified a few word choices to be better suited for kids like 'sudda' instead of 'rensa' (two words for 'clear'). Hmm, this was hard... :-)"

	self translateMethodInterfaceWordings: #(
(append: 'lgg till' 'Lgg till objektet i mitt innehll')
(beep: 'spela ljud' 'Spela upp angivet ljud')
(bounce: 'studsa' 'studsa bort frn kanten ifall den trffas')
(cameraPoint 'kameraposition' 'kamerans position')
(clear 'sudda' 'Sudda bildens innehll')
(clearOwnersPenTrails 'sudda alla pennstreck' 'Sudda alla pennstreck i pennans lekplats')
(clearTurtleTrails 'sudda pennstreck' 'Sudda alla pennstreck p insidan')
(color:sees: 'frg syns' 'ifall vald frg ser angiven frg')
(deleteCard 'Ta bort kort' 'Ta bort det nuvarande kortet')
(doMenuItem: 'utfr menyval' 'utfr menyvalet')
(doScript: 'kr' 'kr skriptet en gng, vid nsta tick')
(emptyScript 'tomt skript' 'ett tomt skript')
(fire 'starta' 'startar alla knapphndelser fr detta objekt')
(firstPage 'frsta sidan' 'g till frsta sidan')
(followPath 'flj vg' 'flj den utsatta vgen')
(forward: 'framt med' 'Flyttar objektet framt i objektets nuvarande riktning')
(getActWhen 'kr nr' 'Nr skriptet skall kras')
(getAllButFirstCharacter 'alla utom frsta' 'Alla mina tecken utom det frsta')
(getAmount 'storlek' 'Frflyttningens storlek')
(getAngle 'vinkel' 'Vinkelfrflyttningens storlek')
(getBorderColor 'kantfrg' 'Frgen p objektets kant')
(getBorderWidth 'kantbredd' 'Bredden p objektets kant')
(getBottom 'botten' 'Den nedersta kanten')
(getBrightnessUnder 'kontrast' 'Kontrasten under objektets mittpunkt')
(getCharacters 'tecken' 'Tecknen i mitt innehll')
(getColor 'frg' 'Objektets frg')
(getColorUnder 'frg under' 'Frgen under objektets mittpunkt')
(getConePosition 'hgtalarposition' 'hgtalarens position')
(getCursor 'markr' 'Markrens nuvarande position, omvxlad till brjan ifall det r lmpligt')
(getDescending 'fallande' 'Sger ifall det minsta vrdet r verst/till vnster (fallande = false) eller nederst/till hger (fallande = true)')
(getDistance 'avstnd' 'Lngden p vektorn mellan ursprungspunkten och objektets position')
(getFirstCharacter 'frsta tecknet' 'Det frsta tecknet i mitt innehll')
(getFirstElement 'frsta elementet' 'Det frsta objektet i mitt innehll')
(getFogColor 'dimmans frg' 'Frgen p dimman som appliceras')
(getFogDensity 'dimmans densitet' 'Densiteten p dimman som appliceras')
(getFogRangeEnd 'dimmans intervallslut' 'Intervallets slut p dimman som appliceras')
(getFogRangeStart 'dimmans intervallstart' 'Intervallets start p dimman som appliceras')
(getFogType 'dimmans typ' 'Typen av dimma som appliceras')
(getGraphic 'bild' 'Bilden som brs av objektet')
(getGraphicAtCursor 'bild vid markr' 'Bilden som brs av objektet vid markren')
(getHeading 'riktning' 't vilket hll objektet pekar. 0 r rakt upp')
(getHeight 'hjd' 'Hjden')
(getHolder 'behllare' 'objektets behllare')
(getIndexInOwner 'elementnummer' 'mitt index i min behllare')
(getIsUnderMouse 'r under muspekaren' 'ifall objektet befinner sig under muspekaren')
(getKnobColor 'draghandtagets frg' 'Draghandtagets frg')
(getLabel 'etikett' 'Texten p knappen')
(getLastValue 'senaste vrde' 'Senast berknade vrde')
(getLeft 'vnster' 'Den vnstra kanten')
(getLeftRight 'vnster/hger' 'Horisontell frflyttning')
(getLuminanceUnder 'ljusstyrka under' 'Ljusstyrkan under objektets mittpunkt')
(getMaxVal 'maxvrde' 'Talet som representerar nr draghandtaget r lngst till hger eller lngst ner, det strsta vrdet som draghandtaget ger.')
(getMinVal 'minvrde' 'Talet som representerar nr draghandtaget r lngst till vnster eller hgst upp, det minsta vrdet som draghandtaget ger.')
(getMouseX 'mus x' 'Muspekarens x-koordinat')
(getMouseY 'mus y' 'Muspekarens y-koordinat')
(getNewClone 'kopia' 'returnerar en kopia det hr objektet')
(getNumberAtCursor 'tal vid markr' 'talet vid markren')
(getNumericValue 'numeriskt vrde' 'Ett tal som representerar den aktuella positionen av draghandtaget.')
(getObtrudes 'sticker ut' 'ifall objektet sticker ut ver behllarens kant')
(getPenColor 'pennfrg' 'frgen p blcket i pennan')
(getPenDown 'penna nedtryckt' 'ifall pennan r nedtryckt just nu')
(getPenSize 'pennans bredd' 'pennans bredd')
(getRight 'hger' 'Den hgra kanten')
(getRoundedCorners 'rundade hrn' 'Ifall hrnen skall vara runda')
(getSampleAtCursor 'vrde vid markr' 'Nuvarande vrde vid markrens position')
(getSaturationUnder 'mttnad under' 'Mttnaden under objektets mittpunkt')
(getScaleFactor 'skalfaktor' 'Objektets frstoringsfaktor')
(getTheta 'theta' 'Vinkeln mellan den positiva x-axeln och vektorn mellan ursprungspunkten och objektets position')
(getTop 'toppen' 'Den versta kanten')
(getTruncate 'trunkera' 'Ifall endast heltal anvnds som vrden, om inte r brktal ocks tilltna.')
(getUpDown 'upp/ner' 'Vertikal frflyttning')
(getValueAtCursor 'spelare vid markr' 'objektet vid markren')
(getViewingByIcon 'normalvy' 'vyn p innehllet r normal')
(getWidth 'bredd' 'Bredden')
(getX 'x' 'X-koordinaten')
(getY 'y' 'Y-koordinaten')
(goToFirstCardInBackground 'g till frsta i bakgrunden' 'G till det frsta kortet i den nuvarande bakgrunden')
(goToFirstCardOfStack 'g till frsta kortet i stacken' 'G till frsta korten i hela stacken')
(goToLastCardInBackground 'g till sista kortet i bakgrunden' 'G till det sista kortet i den nuvarande bakgrunden')
(goToLastCardOfStack 'g till sista kortet i stacken' 'G till det sista kortet i hela stacken')
(goToNextCardInStack 'g till nsta kort' 'G till nsta kort i stacken')
(goToPreviousCardInStack 'g till frra kortet' 'G till det fregende kortet i stacken')
(goToRightOf: 'align after' 'placera detta objekt till hger om ett annat')
(goto: 'g till' 'g till angiven sida')
(hide 'gm' 'gr objektet osynligt')
(initiatePainting 'brja mlning' 'Pbrja mlning av ett nytt objekt i den vanliga lekplatsen.')
(insertCard 'stoppa in kort' 'Skapa ett nytt kort')
(lastPage 'sista sidan' 'g till sista sidan')
(liftAllPens 'lyft alla pennor' 'Lyft pennorna p mitt innehlls alla objekt.')
(loadSineWave 'ladda sinusvg' 'Ladda en sinusvg som nuvarande graf')
(loadSound: 'ladda ljud' 'Ladda angivet ljud som nuvarnde graf')
(lowerAllPens 'snk alla pennor' 'Snk pennorna p mitt innehlls alla objekt.')
(makeNewDrawingIn: 'pbrja mlning i' 'gr en ny mlning i angiven lekplats')
(moveToward: 'flytta mot' 'flytta mot angivet objekt')
(nextPage 'nsta sida' 'g till nsta sida')
(pauseAll: 'pausa alla' 'pausa skriptet i objektet och alla dess kusiner')
(pauseScript: 'pausa skript' 'pausa skriptet')
(play 'spela' 'Spela nuvarande graf som ett ljud')
(previousPage 'fregende sida' 'g till fregende sida')
(removeAll 'ta bort alla' 'Ta bort alla element frn lekplatsen')
(reverse 'reversera' 'Reversera grafen')
(roundUpStrays 'samla in bortsprungna' 'Samla in alla delar utanfr behllaren s att de blir synliga igen.')
(seesColor: 'r ver frg' 'ifall ngon del av objektet r ver den givna frgen')
(show 'visa' 'gr objektet synligt')
(shuffleContents 'blanda innehll' 'Blanda lekplatsens innehll')
(stampAndErase 'stmpla och frsvinn' 'lgg till min bild som ritstreck och frsvinn')
(startAll: 'starta alla' 'starta skriptet tickande i objektet och alla dess kusiner.')
(startScript: 'starta skript' 'starta skriptet tickande')
(stopAll: 'stoppa alla' 'gr skriptet "normalt" i objektet och alla dess kusiner')
(stopScript: 'stoppa skript' 'gr skriptet "normalt" i objektet')
(tellAllSiblings: 'sg till kusiner' 'skicka ett meddelande till alla kusiner')
(touchesA: 'vidrr' 'Ifall jag vidrr ngot som ser ut som...')
(turn: 'svng med' 'ndra objektets riktning med angiven mngd')
(unhideHiddenObjects 'visa alla gmda objekt' 'Gr alla gmda objekt synliga.')
(wearCostumeOf: 'se ut som' 'br samma drkt som...')
(wrap 'vxla ver kant' 'vxla ver kanten ifall det r lmpligt')) language: #Svenska.

	self translateCategories: #(
(basic					'grunder'				'ett antal viktiga saker')
(#'book navigation'		'boknavigering'			'saker som har att gra med bcker och stackar med mera')
(button					'knapp'					'objektet betraktat som en knapp man kan trycka p')
(collections				'samlingar'				'objektet betraktat som en samling av andra objekt')
(fog					'dimma'					'3-dimensionell dimma')
(geometry				'geometri' 				'mtvrden och koordinater')
(#'color & border'		'frger & kanter'		'saker som har att gra med frger och kanter p objekt')
(graphics				'grafik'					'objektet betraktat som en bild')
(#'instance variables'	'instansvariabler'		'instansvariabler tillagda i detta objekt')
(joystick				'joystick	'				'objektet som en joystick')
(miscellaneous			'diverse' 				'diverse kommandon')
(motion					'rrelse' 				'saker som har att gra med frflyttning och vridning')
(paintbox				'mlarlda'				'mlarpaletten')
(#'pen trails'			'pennstreck'				'saker som har att gra med streck som pennan ritar')
(#'pen use'				'pennanvndning' 		'anvndning av ett objekts penna')
(playfield				'lekplats'					'objektet som behllare fr andra synliga objekt')
(sampling				'provtagning'			'provtagning')
(scripts					'skript'					'metoder tillagda i detta objekt')
(slider					'draghandtag'			'anvndbara funktioner fr draghandtag')
(speaker				'hgtalare'				'objektet betraktat som en hgtalare')
(#'stack navigation'		'stacknavigering'		'navigering inom en stack')
(storyboard				'storyboard'				'storyboard')
(tests					'tester'					'ja/nej tester, fr anvndning skriptens testytor')
(text					'text'					'Objektet som text')
(viewing				'vyer'					'Saker som har att gra med olika vyer')
(vector					'vektor'					'Objektet som en vektor')
 ) language: #Svenska.

	self addToTranslationTableFrom: #(
(:						'_'						'tilldela vrde')
(Incr:					'ka med'			'ka vrde med')
(Decr:					'minska med'			'minska vrde med')
(Mult:					'multiplicera med'			'multiplicera vrde med')) language: #Svenska
! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'sw 4/28/2002 16:17'!
initializeLanguageTable
	"Initialize the default set of natural langauges. Others can be added dynamically by sending #setTranslationInitializ:forLanguageSymbol:"

	LanguageTable _ Dictionary new.
	#(	(English		addEnglishVocabulary)
		(Deutsch	addGermanVocabulary)
		(#'Espaol'	addSpanishVocabulary)
		(Kiswahili	addKiswahiliVocabulary)
		(Nederlands	addDutchVocabulary)
		(Norsk		addNorwegianVocabulary)
		(Svenska	addSwedishVocabulary)) do:

		[:pair | LanguageTable at: pair first put: pair second].

	"Vocabulary initializeLanguageTable"! !

"Postscript:"
Vocabulary initializeLanguageTable.
!

