'From Squeak3.3alpha of 18 January 2002 [latest update: #4847] on 28 April 2002 at 11:51:57 pm'!
"Change Set:		actionMap-rw
Date:			28 April 2002
Author:			Rob Withers

Published as 4848actionMap-rw.cs in 3.3a.

Fixes up a couple of problems with the action map in the new events code."!


!Morph methodsFor: 'events' stamp: 'rw 4/25/2002 07:18'!
actionMap
	"Answer an action map"

	| actionMap |
	actionMap := self valueOfProperty: #actionMap.
	actionMap ifNil:
		[actionMap _ self createActionMap].
	^ actionMap! !

!Morph methodsFor: 'events' stamp: 'rw 4/25/2002 07:18'!
releaseActionMap
	"Release the action map"
	
 	self removeProperty: #actionMap! !

!Morph methodsFor: 'events' stamp: 'rw 4/25/2002 07:17'!
updateableActionMap
	"Answer an updateable action map, saving it in my #actionMap property"
	
	| actionMap |
	actionMap := self valueOfProperty: #actionMap.
	actionMap ifNil:
		[actionMap _ self createActionMap.
		self setProperty: #actionMap toValue: actionMap].
	^ actionMap! !

