'From Squeak3.4beta of ''1 December 2002'' [latest update: #5156] on 5 January 2003 at 5:05:56 pm'!
AbstractFont subclass: #PasswordFont
	instanceVariableNames: 'baseFont '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:58'!
ascent
	^baseFont ascent! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
baseFont
	^baseFont! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
baseFont: aFont
	baseFont := aFont! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:59'!
baseKern
	^baseFont baseKern! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 17:00'!
descent
	^baseFont descent! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:58'!
descentKern
	^baseFont descentKern! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:58'!
emphasized: emph
	^PasswordFont new baseFont: (baseFont emphasized: emph)! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
height
	^baseFont height! !

!PasswordFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:59'!
passwordCharacter
	^$*! !

!PasswordFont methodsFor: 'measuring' stamp: 'ar 1/5/2003 17:02'!
widthOf: aCharacter
	^baseFont widthOf: self passwordCharacter! !

!PasswordFont methodsFor: 'displaying' stamp: 'ar 1/5/2003 17:02'!
displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta
	| maskedString |
	maskedString := String new: (stopIndex-startIndex+1).
	maskedString atAllPut: self passwordCharacter.
	^baseFont 
		displayString: maskedString 
		on: aDisplayContext 
		from: 1 
		to: maskedString size 
		at: aPoint 
		kern: kernDelta! !

!PasswordFont methodsFor: 'displaying' stamp: 'ar 1/5/2003 17:00'!
installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor
	^baseFont installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor! !


!StrikeFont class methodsFor: 'instance creation' stamp: 'ar 1/5/2003 16:56'!
passwordFontSize: aSize
	^PasswordFont new baseFont: 
		((StrikeFont familyName: #NewYork10 size: aSize) copy)! !


