'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5420] on 24 September 2003 at 10:14:44 am'!
"Change Set:		InvalidationOptimization-nk
Date:			24 September 2003
Author:			Ned Konz

This CS skips invalidation of rectangles whose width or height is 0.

This eliminates huge amounts of unnecessary redrawing (much of it out of bounds!!) with PluggableListMorphs.

You can see the difference by doing this before and after you load this CS:

* open a browser.
* Bring up a halo on the class category list's listmorph.
* inspect the morph
* turn on the debugShowDamage preference
* evaluate this in the inspector:
   model changed: (self getListSelector)

"!


!Morph methodsFor: 'change reporting' stamp: 'nk 9/24/2003 10:01'!
invalidRect: aRectangle from: aMorph
	| damageRect |
	aRectangle hasPositiveExtent ifFalse: [ ^self ].
	damageRect _ aRectangle.
	aMorph == self ifFalse:[
		"Clip to receiver's clipping bounds if the damage came from a child"
		self clipSubmorphs 
			ifTrue:[damageRect _ aRectangle intersect: self clippingBounds]].
	owner ifNotNil: [owner invalidRect: damageRect from: self].
	self wonderlandTexture ifNotNil:[self isValidWonderlandTexture: false].
! !

