'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5421] on 17 October 2003 at 9:43:41 am'!
"Change Set:		ansiAssignmentOp-brp
Date:			17 October 2003
Author:			Brent Pinkney

This change set adds a new preference to Squeak to control whether the assignment operator is displayed as a _ or as a :=.

This preference only takes effect if browseWithPrettyPrint is true."!


!AssignmentNode methodsFor: 'printing' stamp: 'brp 10/8/2003 14:55'!
printOn: aStream indent: level 
	aStream dialect = #SQ00
		ifTrue: [aStream
				withStyleFor: #setOrReturn
				do: [aStream nextPutAll: 'Set '].
			variable printOn: aStream indent: level.
			aStream
				withStyleFor: #setOrReturn
				do: [aStream nextPutAll: ' to '].
			value printOn: aStream indent: level + 2]
		ifFalse: [variable printOn: aStream indent: level.
			aStream
				nextPutAll: (Preferences ansiAssignmentOperatorWhenPrettyPrinting
						ifTrue: [' := ']
						ifFalse: [' _ ']).
			value printOn: aStream indent: level + 2]! !


!Preferences class methodsFor: 'standard queries'!
ansiAssignmentOperatorWhenPrettyPrinting
	^ self
		valueOfFlag: #ansiAssignmentOperatorWhenPrettyPrinting
		ifAbsent: [true]! !

"Postscript:
This postcript installs the new preference"

Preferences
	addPreference: #ansiAssignmentOperatorWhenPrettyPrinting
	category: #browsing 
	default: true
	balloonHelp: 'If true, then when browseWithPrettyPrint is in effect, the assignment operator will be presented as :='.!

