'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5169] on 22 February 2003 at 9:41:29 pm'!
"Change Set:		StringMorphFontEmp-efc
Date:			22 February 2003
Author:			Eddie Cottongim

Fixes a bug with StringMorph that caused the text to lose its emphasis if you change the font, and lose its font if you changed the emphasis."!


!StringMorph methodsFor: 'printing' stamp: 'efc 2/22/2003 21:35'!
font: aFont 
	"Set the font my text will use. The emphasis remains unchanged."

	font _ aFont.
	^ self font: font emphasis: emphasis! !

!StringMorph methodsFor: 'font' stamp: 'efc 2/22/2003 21:35'!
emphasis: aNumber
	"Set the receiver's emphasis as indicated. aNumber is a bitmask with the following format:

	bit	attribute
	1	bold
	2	italic
	4	underlined
	8	narrow
	16	struckOut"

	"examples: 0 -> plain.  
	1 -> bold.  2 -> italic.  3 -> bold italic.  4 -> underlined  
	5 -> bold underlined.  6 -> italic underlined.   7 -> bold italic underlined   
	etc..."

	emphasis _ aNumber.
	^ self font: font emphasis: emphasis! !

