'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5566] on 1 December 2003 at 7:35:32 pm'!
"Change Set:		AcornPathPartsFixes
Date:			1 December 2003
Author:			tim@sumeru.stanford.edu

The Risc OS specific fix for pathParts - not dependent on the generic pathParts fixes package."!


!AcornFileDirectory methodsFor: 'path access' stamp: 'tpr 11/30/2003 21:42'!
pathParts
	"Return the path from the root of the file system to this directory as an 
	array of directory names.
	This version tries to cope with the RISC OS' strange filename formatting; 
	filesystem::discname/$/path/to/file
	where the $ needs to be considered part of the filingsystem-discname atom."
	| pathList |
	pathList := super pathParts.
	(pathList indexOf: '$') = 2
		ifTrue: ["if the second atom is root ($) then stick $ on the first atom 
				and drop the second. Yuck"
			^ Array
				streamContents: [:a | 
					a nextPut: (pathList at: 1), '/$'.
					3 to: pathList size do: [:i | a
								nextPut: (pathList at: i)]]].
	^ pathList! !

