'From Squeak3.7alpha of 11 September 2003 [latest update: #5595] on 3 December 2003 at 8:29:56 pm'!
"Change Set:		openDebuggerOnFailingTestCase-brp
Date:			3 December 2003
Author:			Brent Pinkney

Not all SUnit test cases inherit directly from TestCase; the developer may have introduced possibly abstract) base classes in between.

If such a test case fails, the failing compiled method may well be in such an inherited class. 

To successfully open a debugger on such a failing method, #lookupSelector: should be used instead of #compiledMethodAt: in TestCase:>>#openDebuggerOnFailingTestMethod.

This was tested in a 3.7a-5595 image. i.e. with the new TestRunner."

!


!TestCase methodsFor: 'Running' stamp: 'brp 12/3/2003 20:09'!
openDebuggerOnFailingTestMethod
	| guineaPig context compiledMethod debugger |
	compiledMethod _ self class lookupSelector: self selector.
	guineaPig _ [ self performTest ] newProcess.
	context _ guineaPig suspendedContext.
	debugger _ Debugger new
		process: guineaPig
		controller: ((Smalltalk isMorphic not and: [ScheduledControllers inActiveControllerProcess])
				ifTrue: [ScheduledControllers activeController]
				ifFalse: [nil])
		context: context
		isolationHead: nil.
	debugger openFullNoSuspendLabel: 'Debug failed test ', self printString.
	[debugger interruptedContext method == compiledMethod]
		whileFalse: [debugger send].
! !

