'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 16 February 2004 at 3:56:10 pm'!
"Change Set:		TextPropertiesMorph-fc
Date:			12 February 2004
Author:			Frank Caggiano
			Ned Konz added revert for extent as well.

 TextMorph 'text color...' interface 'cancel' button doesn't work

Not just a problem with the cancel button. The TextMorph created inside the TextPropertiesMorph (activeTextMorph) and the TextMorph being edited (myTarget) were sharing the same attributes. Certain changes (color, text style)  to the activeTextMorph were immeditely set in myTagret. This could be seen by forcing myTagret to redraw itself even while the textPropertiesMorph was still up (for example clicking the wrap button or covering and uncovering the target text morph).

There still might be an issue with the wrap button.  I'm not really sure how it is suppose to work."!


!TextPropertiesMorph methodsFor: 'initialization' stamp: 'nk 2/12/2004 13:06'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	applyToWholeText _ true.
	myTarget
		ifNil: [""
			myTarget _ TextMorph new openInWorld.
			myTarget contents: ''].

	activeTextMorph _ myTarget copy.
	activeTextMorph extent: 300 @ 100;	 
			 releaseCachedState.
	thingsToRevert
		at: #wrapFlag: put: myTarget isWrapped;
		 at: #autoFit: put: myTarget isAutoFit;
		 at: #margins: put: myTarget margins;
		at: #extent: put: myTarget extent.
	self rebuild! !

