'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 13 February 2004 at 4:33:02 pm'!
"Change Set:		MorphFileInFix-bf
Date:			13 February 2004
Author:			Bert Freudenberg

Loading a morph from file opened the file in read/write mode, resulting in the inability to load a read-only morph file. Fixed."!


!Morph class methodsFor: 'fileIn/Out' stamp: 'bf 2/13/2004 16:28'!
fromFileName: fullName
	"Reconstitute a Morph from the file, presumed to be represent a Morph saved
	via the SmartRefStream mechanism, and open it in an appropriate Morphic world"

 	| aFileStream morphOrList |
	aFileStream _ FileStream readOnlyFileNamed: fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
	(morphOrList isKindOf: SqueakPage) ifTrue: [morphOrList _ morphOrList contentsMorph].
	Smalltalk isMorphic
		ifTrue: [ActiveWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[morphOrList isMorph ifFalse: [self inform: 'Can only load a single morph
into an mvc project via this mechanism.'].
			morphOrList openInWorld]! !

