'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 8 April 2004 at 7:02:39 pm'!
"Change Set:		ObjectsToolsBabel-dgd
Date:			8 April 2004
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

The buttons for categories are now translatable (just like in Small-Land image).

"!


!ObjectsTool methodsFor: 'categories' stamp: 'dgd 4/8/2004 18:59'!
showCategory: aCategoryName fromButton: aButton
	"Project items from the given category into my lower pane"

	| quads  |
	submorphs last removeAllMorphs.
	quads _ OrderedCollection new.
	Morph withAllSubclasses do:
		[:aClass | aClass theNonMetaClass addPartsDescriptorQuadsTo: quads if: [:aDescription | aDescription translatedCategories includes: aCategoryName]].
	quads _ quads asSortedCollection:
		[:q1 :q2 | q1 third <= q2 third].
	self installQuads: quads fromButton: aButton! !

!ObjectsTool methodsFor: 'categories' stamp: 'dgd 4/8/2004 18:59'!
tabsForCategories
	"Answer a list of buttons which, when hit, will trigger the choice of a category"

	| buttonList aButton classes categoryList |
	classes _ Morph withAllSubclasses.
	categoryList _ Set new.
	classes do: [:aClass |
		(aClass class includesSelector: #descriptionForPartsBin) ifTrue:
			[categoryList addAll: aClass descriptionForPartsBin translatedCategories].
		(aClass class includesSelector: #supplementaryPartsDescriptions) ifTrue:
			[aClass supplementaryPartsDescriptions do:
				[:aDescription | categoryList addAll: aDescription translatedCategories]]].
	categoryList _ categoryList asSortedArray.

	buttonList _ categoryList collect:
		[:catName |
			aButton _ SimpleButtonMorph new label: catName.
			aButton actWhen: #buttonDown.
			aButton target: self; actionSelector: #showCategory:fromButton:; arguments: {catName. aButton}].
	^ buttonList

"ObjectsTool new tabsForCategories"! !

