'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 14 April 2004 at 1:10:54 pm'!
"Change Set:		norwQuote-ls
Date:			10 April 2004
Author:			Lex Spoon

Fixes the quoting in the translation method for Norwegian.  The Squeak compiler is happy with either version, but the Refactoring Browser needs the quotes to balance more strictly.

This problem may point to a bug in Squeak's scanner of literal arrays.

(merged conflict with 5768. -dew)"!


!EToyVocabulary methodsFor: 'language translations' stamp: 'ls 3/20/2004 14:37'!
addNorwegianVocabulary
	"Add a Norwegian vocabulary. "

	self translateMethodInterfaceWordings: #(
(append: 'legg til' 'Legg til objektet i mitt innehold')
(beep: 'spill lyd' 'Spill denne lyden')
(bounce: 'sprett' 'sprett bort fra kanten om den treffes')
(cameraPoint 'kameraposisjon' 'kamerans posisjon')
(clear 'rens' 'Rens bort bildet')
(clearOwnersPenTrails 'rens alla pennestrk' 'Rens bort alle pennestrk i pennens lekeplass')
(clearTurtleTrails 'rens skilpaddestrk' 'Rens bort alle skilpaddestrk p innsiden')
(color:sees: 'farge syns' 'Om valgte farge ser angitt farge')
(deleteCard 'Ta bort kort' 'Ta bort dette kortet')
(doMenuItem: 'utfr menyvalg' 'utfr menyvalget')
(doScript: 'kjr' 'kjr skriptet en gang, ved nesta tick')
(emptyScript 'tomt skript' 'et tomt skript')
(fire 'starta' 'starter alle knapphendelser for dette objektet')
(firstPage 'frsta siden' 'g till frsta siden')
(followPath 'flg vei' 'flg denne veien')
(forward: 'framover med' 'Flytter objektet framover i objektets nvrende rettning')
(getActWhen 'kjr nr' 'Nr skriptet skal kjres')
(getAllButFirstCharacter 'alle uten om frsta' 'Alle mine tegn uten om det frste')
(getAmount 'strrelse' 'Forflyttningens strrelse')
(getAngle 'vinkel' 'Vinkelforflyttningens strrelse')
(getBorderColor 'kantfarge' 'Fargen p objektets kant')
(getBorderWidth 'kantbredde' 'Bredden p objektets kant')
(getBottom 'bunn' 'Den nederste kanten')
(getBrightnessUnder 'kontrast' 'Kontrasten under objektets mittpunkt')
(getCharacters 'tegn' 'Tegnet i mitt innehold')
(getColor 'farge' 'Objektets farge')
(getColorUnder 'farge under' 'Fargen under objektets mittpunkt')
(getConePosition 'hytalerposition' 'hytalerens position')
(getCursor 'markr' 'Markrens nvrende position, ombytt til frste om det er mulig')
(getDescending 'fallende' 'Sier om den minste verdien er verst / til venstre (fallende = false) eller nederst / til hyre (fallande = true)')
(getDistance 'avstand' 'Lengden p vektoren mellom utgangspunktet og objektets posisjon')
(getFirstCharacter 'frste tegnet' 'Det frste tegnet i mitt innehold')
(getFirstElement 'frsta elementet' 'Det frsta objektet i mitt innehold')
(getFogColor 'tkens farge' 'Fargen p tken som benyttes')
(getFogDensity 'tkens tetthet' 'Tettheten p tken som benyttes')
(getFogRangeEnd 'tkens intervalslutt' 'Intervalets slutt p tken som benyttes')
(getFogRangeStart 'tkens intervalstart' 'Intervalets start p tken som benyttes')
(getFogType 'tkens typ' 'Typen av tke som benyttes')
(getGraphic 'bilde' 'Bildet som bres av objektet')
(getGraphicAtCursor 'bilde ved markr' 'Bildet som bres av objektet ved markren')
(getHeading 'rettning' 'I vilken rettning objektet peker. 0 er rett opp')
(getHeight 'hyde' 'Hyden')
(getHolder 'beholder' 'objektets beholder')
(getIndexInOwner 'elementnummer' 'mitt indeksnummer i min beholdere')
(getIsUnderMouse 'er under muspekeren' 'om objektet befinner seg under muspekeren')
(getKnobColor 'hndtakets farge' 'Hndtakets farge')
(getLabel 'etikett' 'Teksten p knappen')
(getLastValue 'seneste verdi' 'Seneste beregnede verdi')
(getLeft 'venstre' 'Den venstre kanten')
(getLeftRight 'venstre/hyre' 'Horisontel forflyttning')
(getLuminanceUnder 'lysstyrke under' 'Lysstyrken under objektets mittpunkt')
(getMaxVal 'maxverdi' 'Tallet som representerer nr hndtaket er lengst til hyre eller lengst ned, den strste verdien som hndtaket gir.')
(getMinVal 'minverdi' 'Tallet som representerer nr hndtaket er lengst til venstre eller hyest opp, den minste verdien som hndtaket gir.')
(getMouseX 'mus x' 'Muspekerens x-koordinat')
(getMouseY 'mus y' 'Muspekerens y-koordinat')
(getNewClone 'kopia' 'returnerer en kopi av det her objektet')
(getNumberAtCursor 'tall ved markr' 'tallet ved markren')
(getNumericValue 'numeriskt verdi' 'Et tall som representerer den aktuelle posisjonen av hndtaket.')
(getObtrudes 'stikker ut' 'om objektet stikker ut over beholderens kant')
(getPenColor 'pennefarge' 'fargen p blekket i pennen')
(getPenDown 'pen nedtrykt' 'om pennen er nedtrykt n')
(getPenSize 'pennens bredde' 'pennens bredde')
(getRight 'hyre' 'Den hyre kanten')
(getRoundedCorners 'rundede hjrner' 'om hjrnene skal vre runde')
(getSampleAtCursor 'verdi ved markr' 'Nvrende verdi ved markrens posisjon')
(getSaturationUnder 'mettning under' 'Fargemettning under objektets mittpunkt')
(getScaleFactor 'skala' 'Objektets skala')
(getTheta 'theta' 'Vinkelen mellom den positive x-axelen og vektoren mellom utgangspunktet og objektets posisjon')
(getTop 'toppen' 'Den verste kanten')
(getTruncate 'heltall' 'Om bare heltall anvendes som verdi, om brktal ikke er tillatt.')
(getUpDown 'opp/ner' 'Vertikal forflyttning')
(getValueAtCursor 'spiller ved markr' 'objektet ved markren')
(getViewingByIcon 'normalt synssett' 'Synsettet p inneholdet er normal')
(getWidth 'bredd' 'Bredden')
(getX 'x' 'X-koordinaten')
(getY 'y' 'Y-koordinaten')
(goToFirstCardInBackground 'g til frste i bakgrunnen' 'G til det frste kortet i den nvrende bakgrunnen')
(goToFirstCardOfStack 'g til frste kortet i stacken' 'G til frste korten i hele stacken')
(goToLastCardInBackground 'g til siste kortet i bakgrunnen' 'G til det siste kortet i den nvrende bakgrunnen')
(goToLastCardOfStack 'g til siste kortet i stacken' 'G til det siste kortet i hele stacken')
(goToNextCardInStack 'g till neste kort' 'G til neste kort i stacken')
(goToPreviousCardInStack 'g til forrige kort' 'G til det forrige kortet i stacken')
(goToRightOf: 'plassere etter' 'plassere dette objekt til hyre om et annet')
(goto: 'g til' 'g til angitt side')
(hide 'gjem' 'gjr objektet usynligt')
(initiatePainting 'begynn malning' 'Begynn malning av et nytt objekt i den vanlige lekeplatsen.')
(insertCard 'legg inn kort' 'Skap et nytt kort')
(lastPage 'siste siden' 'g til siste siden')
(liftAllPens 'lft alle penner' 'Lft pennene p mitt inneholds alle objekt.')
(loadSineWave 'pne sinusblge' 'pne en sinusblge som nvrende graf')
(loadSound: 'pne lyd' 'pne angivet lyd som nvrende lyd')
(lowerAllPens 'senk alle penner' 'Senk pennene p mitt inneholds alle objekt.')
(makeNewDrawingIn: 'bgynn malning i' 'lag en ny malning i angiven lekeplats')
(moveToward: 'flytte mot' 'flytte mot angivet objekt')
(nextPage 'nesta side' 'g til neste side')
(pauseAll: 'pause alle' 'pause skriptet i objektet och alle dets slekninger')
(pauseScript: 'pause skript' 'pause skriptet')
(play 'spela' 'Spill nvrende graf som en lyd')
(previousPage 'foregende side' 'g til foregende side')
(removeAll 'ta bort alle' 'Ta bort alle element fra lekeplatsen')
(reverse 'reversere' 'Reversere grafen')
(roundUpStrays 'samle inn bortsprungne' 'Samle inn alle deler utenfor beholderen s at de blir synlige igen.')
(seesColor: 'er over farge' 'om noen del av objektet er over den angitte fargen')
(show 'vise' 'gjr objektet synlig')
(shuffleContents 'blande innehold' 'Blande lekeplatsens innehold')
(stampAndErase 'stemple og forsvinn' 'legg til mitt bilde som tegnestrek och forsvinn')
(startAll: 'start alle' 'start skriptet tickende i objektet och alla dets slekninger.')
(startScript: 'start skript' 'start skriptet tickende')
(stopAll: 'stopp alle' 'gjr skriptet "normalt" i objektet och alla dets slektninger')
(stopScript: 'stopp skript' 'gjr skriptet "normalt" i objektet')
(tellAllSiblings: 'si til slekninger' 'send et meddelende til alla slekninger')
(touchesA: 'rrer' 'Om jeg rrer noe som ser ut som...')
(turn: 'sving med' 'Endre objektets retning med angitt mengde')
(unhideHiddenObjects 'vise alle gjemte objekt' 'Gjr alle gjemte objekt synlige.')
(wearCostumeOf: 'se ut som' 'br samme drakt som...')
(wrap 'fold over kant' 'fold over kanten om det er passende')) language: #Norsk.

	self translateCategories: #(
(basic					'elementre'				'et antall viktige saker')
(#'book navigation'		'boknavigering'			'saker som har med bker och stackar  gjre')
(button					'knapp'					'objektet betraktet som en knapp man kan trykke p')
(collections				'samlinger'				'objektet betraktet som en samling av andre objekt')
(fog					'tke'					'3-dimensionell tke')
(geometry				'geometri' 				'verdier og koordinater')
(#'color & border'		'farger & kanter'		'saker som har med farger og kanter p objekt  gjre')
(graphics				'grafikk'					'objektet betraktat som et bilde')
(variables				'instansvariabler'		'instansvariabler tilhrende dette objektet')
(joystick				'joystick	'				'objektet som en joystick')
(miscellaneous			'diverse' 				'diverse kommander')
(motion					'rrelse' 				'saker som har med forflyttning och vridning  gjre')
(paintbox				'maleskrin'				'malepaletten')
(#'pen trails'			'pennestrk'				'saker som har med strk som pennen tegner  gjre')
(#'pen use'				'pen bruk' 		'bruk av et objekts pen')
(playfield				'lekeplats'					'objektet som beholdere for andre synlige objekt')
(sampling				'prvetagning'			'prvetagning')
(scripts					'skript'					'metoder lagt til dette objektet')
(slider					'hndtak'			'nyttige funksjoner for hndtak')
(speaker				'hytaler'				'objektet sett som en hytaler')
(#'stack navigation'		'stacknavigering'		'navigering innen en stack')
(storyboard				'storyboard'				'storyboard')
(tests					'tester'					'for  lage ja/nei tester i script')
(text					'tekst'					'Objektet som tekst')
(viewing				'seer'					'Saker som har med olika seeren  gjre')
(vector					'vektor'					'Objektet som en vektor')
 ) language: #Norsk.

	self addToTranslationTableFrom: #(
(:						'_'						'gi verdi')
(Incr:					'ke med'			'ka verdi med')
(Decr:					'minske med'			'minske verdi med')
(Mult:					'multiplicera med'			'multiplisere verdi med')) language: #Norsk! !

