'From Squeak3.7-m17n of 30 June 2004 [latest update: #6] on 8 July 2004 at 1:19:15 pm'!
"Change Set:		converterRefacor
Date:			8 July 2004
Author:			Yoshiki Ohshima

A fix to logic error leads to a refactoring."!


!Latin1TextConverter methodsFor: 'as yet unclassified' stamp: 'yo 7/12/2004 10:57'!
nextPut: aCharacter toStream: aStream 

	aStream basicNextPut: (Character value: aCharacter charCode).
! !


!AbstractString methodsFor: 'converting' stamp: 'yo 7/8/2004 12:02'!
convertFromWithConverter: converter

	| readStream writeStream c |
	readStream _ self readStream.
	writeStream _ String new writeStream.
	converter ifNil: [^ self].
	[readStream atEnd] whileFalse: [
		c _ converter nextFromStream: readStream.
		c ifNotNil: [writeStream nextPut: c] ifNil: [^ writeStream contents]
	].
	^ writeStream contents
! !

!AbstractString methodsFor: 'converting' stamp: 'yo 7/8/2004 12:01'!
convertToWithConverter: converter

	| readStream writeStream |
	readStream _ self readStream.
	writeStream _ String new writeStream.
	converter ifNil: [^ self].
	[readStream atEnd] whileFalse: [
		converter nextPut: readStream next toStream: writeStream
	].
	converter emitSequenceToResetStateIfNeededOn: writeStream.
	^ writeStream contents.
! !

String removeSelector: #convertFromWithConverter:!
String removeSelector: #convertToWithConverter:!
MultiString removeSelector: #convertFromWithConverter:!
MultiString removeSelector: #convertToWithConverter:!
