'From Squeak3.7gamma of ''17 July 2004'' [latest update: #5985] on 19 August 2004 at 4:54:11 am'!
"Change Set:		TextPlusMorphFocusFix
Date:			19 August 2004
Author:			Andreas Gerdes

Fixes the focus of a TextPlusMorph not showing up (no cursor in a GeeMailMorph)"!


!TextPlusMorph methodsFor: 'event handling' stamp: 'ag 8/19/2004 04:53'!
keyboardFocusChange: aBoolean

	| parent |

	"we basically ignore loss of focus unless it is going to one of our siblings"
	aBoolean ifFalse: [^self].

	paragraph isNil ifFalse:[paragraph focused: aBoolean].

	"A hand is wanting to send us characters..."
	self hasFocus ifFalse: [self editor "Forces install"].

	"Inform our siblings we have taken the focus"
	parent _ self parentGeeMail ifNil: [^self].
	parent allTextPlusMorphs do: [ :each |
		each == self ifFalse: [each keyboardFocusLostForSure]
	].

! !

