'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #267] on 28 August 2004 at 8:58:06 pm'!
"Change Set:		dupHandle-sw
Date:			28 August 2004
Author:			Scott Wallace

Makes ScriptEditorMorphs decline to put up a duplication handle, provided that selectiveHalos preference is true."!


!ScriptEditorMorph methodsFor: 'initialization' stamp: 'sw 8/28/2004 20:57'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 cellPositioning: #topLeft;
		 setProperty: #autoFitContents toValue: true;
	 layoutInset: 2;
	 useRoundedCorners.
	self setNameTo: 'Script Editor' translated.
	firstTileRow _ 1.
	"index of first tile-carrying submorph"
	self addNewRow.
	showingMethodPane _ false! !

!ScriptEditorMorph methodsFor: 'menus' stamp: 'sw 8/28/2004 20:55'!
wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph
	"Answer whether the receiver would like to offer the halo handle with the given selector (e.g. #addCollapseHandle:)"

	(#(addDupHandle: addMakeSiblingHandle:) includes: aSelector) ifTrue:
		[^ false].

	^ super wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph! !

