'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #267] on 31 August 2004 at 3:42:05 pm'!
"Change Set:		TextMorphLineHeightFix-nk
Date:			31 August 2004
Author:			Ned Konz

Another fix for bug 000081.

This checks to see if the text attributes have changed and updates the paragraph if they have.
"!


!TextMorph methodsFor: 'editing' stamp: 'nk 8/31/2004 15:31'!
handleInteraction: interactionBlock fromEvent: evt
	"Perform the changes in interactionBlock, noting any change in selection
	and possibly a change in the size of the paragraph (ar 9/22/2001 - added for TextPrintIts)"
	"Also couple ParagraphEditor to Morphic keyboard events"
	| oldEditor oldParagraph oldText |
	self editor sensor: (KeyboardBuffer new startingEvent: evt).
	oldEditor _ editor.
	oldParagraph _ paragraph.
	oldText _ oldParagraph text copy.

	self selectionChanged.  "Note old selection"

		interactionBlock value.

	(oldParagraph == paragraph) ifTrue:[
		"this will not work if the paragraph changed"
		editor _ oldEditor.     "since it may have been changed while in block"
	].
	self selectionChanged.  "Note new selection"
	(oldText = paragraph text and: [ oldText runs = paragraph text runs ])
		ifFalse:[ self updateFromParagraph ].
	self setCompositionWindow.! !

