'From Small-Land 3.8-5976-0266 of 10 September 2004 [latest update: #5976] on 11 September 2004 at 9:17:17 pm'!
"Change Set:		SelectionEnh-dgd
Date:			11 September 2004
Author:			Diego Gomez Deck

Removes of dead and useless code:
- SelectionMorph>>extendByHandPlus: was just a duplication of SelectionMorph>>extendByHand:
- TextPlusPasteUpMorph>>dragThroughOnDesktop: (the only sender of #extendByHandPlus:) was a duplication of  PasteUpMorph>>dragThroughOnDesktop:

Improvement:
- When a Selection is made containing only one object, the SelectionMorph is removed and the halo for the enclosed object is brought up.

NOTE: This changes are useful in combination with the (coming) EasySelection-dgd changeset.

"!


!SelectionMorph methodsFor: 'initialization' stamp: 'dgd 9/11/2004 21:07'!
extendByHand: aHand
	"Assumes selection has just been created and added to some pasteUp or world"
	| startPoint handle |

	startPoint := self position.

	handle := NewHandleMorph new followHand: aHand
		forEachPointDo: [:newPoint |
					| localPt |
					localPt := (self transformFrom: self world) globalPointToLocal: newPoint.
					self bounds: (startPoint rect: localPt)
				]
		lastPointDo: [:newPoint |
					selectedItems isEmpty
						ifTrue: [self delete]
						ifFalse: [
							selectedItems size = 1
								ifTrue:[self delete.  selectedItems anyOne addHalo]
								ifFalse:[self doneExtending]
						]
				].

	aHand attachMorph: handle.
	handle startStepping.! !

TextPlusPasteUpMorph removeSelector: #dragThroughOnDesktop:!
SelectionMorph removeSelector: #extendByHandPlus:!
