'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 13 October 2004 at 4:13:52 pm'!
"Change Set:		backwarCompatibleDepr-md
Date:			13 October 2004
Author:			Marcus Denker

This adds #backwardCompatibilityOnly: to Object. This
can be used instead of deprecated: to tag methods that
are deprecated but will be kept for compatibility

It chnages Smalltalk>>version to use that."!


!Object methodsFor: 'error handling' stamp: 'md 10/13/2004 15:59'!
backwardCompatibilityOnly: anExplanationString
	"Warn that the sending method has been deprecated. Methods that are tagt with #backwardCompatibility:
	 are kept for compatibility."

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation signal: thisContext sender printString, ' has been deprecated (but will be kept for compatibility). ', anExplanationString]! !


!SystemDictionary methodsFor: 'sources, change log' stamp: 'md 10/13/2004 15:58'!
version
	"Answer the version of this release."

	self backwardCompatibilityOnly: 'Use SystemVersion current version'.
	^SystemVersion current version! !

