'From Squeak3.9alpha of 4 July 2005 [latest update: #6681] on 30 August 2005 at 10:13:05 pm'!

!GradientFillStyle commentStamp: 'efc 8/30/2005 21:44' prior: 0!
A gradient fill style is a fill which interpolates smoothly between any number of colors.

Instance variables:
	colorRamp	<Array of: Association> Contains the colors and their relative positions along the fill, which is a number between zero and one.
	pixelRamp	<Bitmap>		A cached version of the colorRamp to avoid needless recomputations.
	radial		<Boolean>	If true, this fill describes a radial gradient. If false, it is a linear gradient.
	isTranslucent	<Boolean>	A (cached) flag determining if there are any translucent colors involved.

Class variables:
	PixelRampCache <LRUCache>	Recently used pixelRamps. They tend to have high temporal locality and this saves space and time.!


"Zap the pixelRamp caches for all existing GradientFillStyle instances. This will force them to go through the new cache the next time a pixelramp is required. This reuse saved about 300k in my image."
GradientFillStyle allInstancesDo:[:each| each pixelRamp: nil ]
!

