'From Squeak 2.0 of May 22, 1998 on 15 June 1998 at 3:49:28 pm'!
"Change Set:		possessiveTile
Date:			15 June 1998
Author:			Scott Wallace

Makes the wording of any object-ref tile show the possessive ending if and only if it is a slot-reference on the object.  Caution:  will not fix up old tiles that predate this fix, only applies to scripts created after this fix is present"!


!TileMorph methodsFor: 'initialization' stamp: 'sw 6/11/1998 17:58'!
bePossessive
	self setProperty: #possessive toValue: true.
	self line1: actualObject externalName, '''s'
! !

!TileMorph methodsFor: 'initialization' stamp: 'sw 6/11/1998 18:00'!
bringUpToDate
	| newLabel |
	type == #objRef ifTrue:
		[newLabel _ actualObject externalName.
		self isPossessive ifTrue:
			[newLabel _ newLabel, '''s'].
		self line1: newLabel]
	! !

!TileMorph methodsFor: 'initialization' stamp: 'sw 6/11/1998 17:58'!
isPossessive
	^ self hasProperty: #possessive! !


!TilePadMorph methodsFor: 'all' stamp: 'sw 6/15/1998 09:21'!
acceptDroppingMorph: aMorph event: evt

	| editor wasPossessive |
	wasPossessive _ submorphs size > 0 and: [submorphs first isPossessive].
	self prepareToUndoDropOf: aMorph.
	self removeAllMorphs.
	aMorph position: self position.
	self addMorph: aMorph.
	wasPossessive ifTrue: [aMorph bePossessive].
	(editor _ self topEditor) ifNotNil: [editor install]
! !


