'From Squeak 2.4c of May 10, 1999 on 26 July 1999 at 3:07:55 pm'!
"Change Set:		WorldState2
Date:			24 July 1999
Author:			Dan Ingalls

Fixes a few obsolete references to PasteUpMorph>>project, and removes it.
Then renames the field 'project' to be 'worldState', consistent with the new factoring.
"!


!FileList methodsFor: 'file list menu' stamp: 'di 7/24/1999 15:44'!
openProjectFromFile
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved via the SmartRefStream mechanism, and open it in an appropriate Morphic world"
 	| aFileStream morphOrList window |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	World ifNil: [^ self inform: 'Later, allow jumping from MVC to Morphic Projects.'].

	aFileStream _ directory oldFileNamed: self fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
	(morphOrList isKindOf: SqueakPage) ifTrue: [
		morphOrList _ morphOrList contentsMorph].
	(morphOrList isKindOf: PasteUpMorph) ifFalse: [
		^ self inform: 'This is not a PasteUpMorph.'].
	(window _ ProjectViewMorph newMorphicProjectOn: morphOrList) openInWorld.
	window model enter! !


!HandMorph methodsFor: 'world menu commands' stamp: 'di 7/24/1999 15:41'!
assert.
	"The changes made in this isolated project will be installed in all projects."

	Project current assert.! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 7/24/1999 15:41'!
beIsolated
	"label this project.  Further method changes made here will be revoked when you leave the project."

	Project current beIsolated.! !


!PasteUpMorph reorganize!
('initialization' initialize)
('classification' isWorldMorph world)
('cursor' cursor cursor: cursorAtEnd rectifyCursor selectedRect valueAtCursor valueAtCursor:)
('display' drawOn: drawSubmorphsOn: padding)
('dropping/grabbing' acceptDroppingMorph:event: allowSubmorphExtraction automaticPhraseExpansion automaticViewing morphToDropFrom: originAtCenter positionNear:forExtent:adjustmentSuggestion: repelsMorph:event: rootForGrabOf: rootMorphsAt: wantsDroppedMorph:event:)
('layout' addCenteredAtBottom:offset: fixLayout insertionIndexFor: laySubpartsOutInOneRow layoutChanged layoutRow:lastRowBase: rowBaseFor:lastRowBase: rowMorphsStartingAt:)
('menu & halo' addCustomMenuItems:hand: addOptionalHandlesTo:box: addPenMenuItems:hand: addPlayfieldMenuItems:hand: addStackMenuItems:hand: autoExpansionString autoLineLayoutString autoViewingString debuggingMenuFor: indicateCursorString isPartsBinString mouseOverHalosString originAtCenterString playfieldOptionsMenu presentPlayfieldMenu showThumbnailString wantsHaloFor:)
('model' createCustomModel model modelOrNil setModel:)
('options' autoLineLayout autoLineLayout: automaticViewing: becomeLikeAHolder behaveLikeHolder indicateCursor indicateCursor: isPartsBin isPartsBin: openToDragNDrop openToDragNDrop: originAtCenter: replaceTallSubmorphsByThumbnails resizeToFit resizeToFit: setPartsBinStatusTo: setThumbnailHeight toggleAlwaysShowThumbnail toggleAutoLineLayout toggleAutomaticPhraseExpansion toggleAutomaticViewing toggleIndicateCursor toggleIsPartsBin toggleMouseOverHalos toggleOriginAtCenter updateSubmorphThumbnails wantsMouseOverHalos wantsMouseOverHalos:)
('painting' backgroundSketch backgroundSketch: deleteBackgroundPainting makeNewDrawingWithin paintBackground paintingBoundsAround: reasonablePaintingExtent)
('pen' clearTurtleTrails createOrResizeTrailsForm drawPenTrailFor:from:to: liftAllPens lowerAllPens trailMorph)
('scripting' addCostumeSpecificCategoriesTo: allTileScriptingElements emptyAnonymousScriptorFrom: emptyPermanentScriptorFrom: expandPhrasesToScripts scriptorForTextualScript:ofPlayer:)
('stack/card' becomeStack doWrap goToNextCard goToPreviousCard installAsCurrent: isStackLike morphsForInstanceData newCard scriptPerformer)
('misc' abandonCostumeHistory allScriptEditors alwaysShowThumbnail cachedOrNewThumbnailFrom: cartesianOrigin color: demandsBoolean fullBounds heightForThumbnails hideViewerFlapsOtherThanFor: impartPrivatePresenter innocuousName invalidRect: isPlayfieldLike makeDetachable maxHeightToAvoidThumbnailing maximumThumbnailWidth mouseX mouseY navigateTo padding: prepareToBeSaved presenter presenter: replaceSubmorph:by: residesInPartsBin roundUpStrays slotNamesAndTypesForBank: smallThumbnailForPageSorter startRunningAll stepAll stopRunningAll thumbnailForPageSorter unhideHiddenObjects updateStatusForAllScriptEditors viewerFlapTabFor: wantsKeyboardFocusFor:)
('object fileIn' convertbosfcebbfgccpmcpbttloiairfidcuw0:bosfcebbfgccpmcpbttloiairfidcuwp0: convertbosfcep0:bosfcepcbbfgccpmcpbttloiairfidcu0: convertbosfcepc0:bosfcepcbbfgccpmcpbttloiairfidcu0: convertbosfcepcbbfgcc0:bosfcepcbbfgccpmcpbttloiairfidcu0: convertbosfcepcbbfgccpmcpbttloiairfidcuw0:bosfcepcbbfgccpmcpbttloiairfidcu0:)
('flaps' accommodateFlap: addGlobalFlaps assureFlapTabsFitOnScreen bringFlapTabsToFront deleteAllFlapArtifacts deleteGlobalFlapArtifacts flapTabs localFlapTabs offsetForAccommodating:onEdge: paintingFlapTab removeAccommodationForFlap:)
('project state' activeHand activeHand: canvas canvas: damageRecorder firstHand hands hands: handsDo: lastCycleTime lastCycleTime: viewBox viewBox:)
('update cycle' startBackgroundProcess)
('stepping' isStepping: runStepMethods startStepping: stopStepping:)
('world state' abandonAllHalos addAllMorphs: addHand: addMorph:centeredNear: addMorphsAndModel: allKnownNames allMorphsDo: allNonFlapRelatedSubmorphs assuredCanvas beWorldForProject: chooseClickTarget colorAt:belowMorph: configureForConstruction convertbosfcebbfgccpmcpbttloiairfidcuwhavcdsllb0:bosfcebbfgccpmcpbttloiairfidcuwhavcdsll0: convertbosfcepcbbfgccpmcpbttloiairfidcuwhavcdslp0:bosfcepcbbfgccpmcpbttloiairfidcuwhavcdslpl0: convertbosfcephvcdslm0:bosfcepcbbfgccpmcpbttloiairfidcuhavcdslp0: displayWorld displayWorldAsTwoTone displayWorldNonIncrementally displayWorldSafely doDeferredUpdating doOneCycle doOneCycleInBackground doOneCycleNow doOneSubCycle drawInvalidAreasOn: exit flashRects:color: fullRepaintNeeded goBack goVGA haloMorphOrNil haloMorphs handleFatalDrawingError: handlesMouseDown: initForProject: install installFlaps installForm: interCyclePause: mouseDown: nextPage open openWithTitle: openWithTitle:cautionOnClose: paintArea paintAreaFor: paintBox patchAt:without:andNothingAbove: pauseEventRecorder previousPage referencePlayfield removeHand: restoreDisplay restoreFlapsDisplay saveAsWorld selectHandsToDrawForDamage: sleep specialNameInModelFor: standardPlayerHit standardSystemController startSteppingSubmorphsOf: storeDataOn: triggerClosingScripts triggerOpeningScripts veryDeepCopyWith:)
!


!PasteUpMorph methodsFor: 'world state' stamp: 'di 7/26/1999 15:01'!
initForProject: aWorldState

	worldState _ aWorldState.
	color _ (Color r:0.937 g: 0.937 b: 0.937).
	fillColor2 _ color.
	self addHand: HandMorph new.
	self setProperty: #automaticPhraseExpansion toValue: true.
	model _ nil.
! !


!PasteUpMorph class methodsFor: 'as yet unclassified' stamp: 'di 7/26/1999 15:02'!
newWorldForProject: projectOrNil 
	"Return a new pasteUpMorph configured as a world (ie project notNil).
	projectOrNil is no longer used."

	^ self new initForProject: WorldState new initForWorld! !


PasteUpMorph removeSelector: #project!
"Postscript:
Rename the project instVar..."
PasteUpMorph renameSilentlyInstVar: 'project' to: 'worldState'!

