'From Squeak 2.5 of August 6, 1999 on 15 September 1999 at 10:34:02 am'!
"Change Set:		onionSkFix-tkLH
Date:			15 September 1999
Author:			Ted Kaehler

The update 1443onionSkin-tkLG fixed two odd bugs.  Scott discovered that if you ever get a draw error, a flag is left on, and the transparent onion skin for the paintBox can't be computed.  This clears that flag.  (This update corrects a bug in the fix.)  It also adds 'start drawing again' and 'start stepping again' to the world menu.
	1443 also fixed a bug in TTGlyph printOn: when contours is nil"!


!SketchEditorMorph methodsFor: 'start & finish' stamp: 'tk 9/15/1999 10:29'!
dimTheWindow
	"Do not call twice!! Installs a morph with an 'onion-skinned' copy of the pixels behind me."

	| dim screen whiteWord |
	"create an 'onion-skinned' version of the stuff on the screen"
	owner outermostMorphThat: [:morph | morph resumeAfterDrawError. false].
		"Clear flags that draw orange rect if was ever an error"
	dim _ owner imageFormForRectangle: self bounds.
	screen _ Color pixelScreenForDepth: dim depth.
	dim depth > 1 ifTrue: [
		whiteWord _ Color white pixelWordForDepth: dim depth.
		screen _ screen collect: [:screenWord | screenWord bitAnd: whiteWord]].
	dim fill: dim boundingBox
		rule: (dim depth = 1 ifTrue: [Form and] ifFalse: [Form paint])
		fillColor: screen.
	dimForm _ SketchMorph new form: dim.
	dimForm position: self position.
	owner
		privateAddMorph: dimForm
		atIndex: (owner submorphs indexOf: self) + 1.
! !


