'From Squeak 2.1 of June 30, 1998 on 16 July 1998'!
"Change Set:		loadMorphFromFileList
Date:			16 July 1998
Author:			Scott Wallace

Allows you to load a saved morph directly from a file list browser."!


!FileList methodsFor: 'file list menu' stamp: 'sw 7/15/1998 19:38'!
fileSelectedMenu: aMenu

	^ aMenu
		labels:
'fileIn
file into new change set
browse changes
copy name to clipboard
open image in a window
read image into GIFImports
load as morph
play midi file
sort by name
sort by size
sort by date
rename
delete
add new file
add new directory
broadcast as update'
		lines: # (4 6 8 12)
		selections: #(fileInSelection fileIntoNewChangeSet browseChanges  copyName
openImageInWindow importImage openMorphFromFile playMidiFile sortByName sortBySize sortByDate renameFile deleteFile addNewFile addNewDirectory putUpdate)
! !

!FileList methodsFor: 'file list menu' stamp: 'sw 7/15/1998 19:36'!
openMorphFromFile
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved via the SmartRefStream mechanism, and open it in an appropriate Morphic world"
 	| aFileStream morphOrList |
	Smalltalk at: #Morph ifAbsent: [^ self beep].

	aFileStream _ directory oldFileNamed: self fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
	World
		ifNotNil:
			[World addMorphsAndModel: morphOrList]
		ifNil:
			[(morphOrList isKindOf: Morph)
				ifFalse:
					[^ self inform: 'can only load a single morph into an mvc project via this mechanism'].
				morphOrList openInWorld]! !


