'From Squeak2.8alpha of 26 January 2000 [latest update: #2103] on 12 May 2000 at 10:44:21 pm'!
"Change Set:		miscFixes-jhm
Date:			12 May 2000
Author:			John Maloney

Two unrelated fixes related to running under Netscape:
  1. fix bug in remote file browsing
  2. allow exiting interpreter loop"!


!Interpreter methodsFor: 'interpreter shell' stamp: 'jm 1/29/2000 13:19'!
interpret

	self internalizeIPandSP.
	self fetchNextBytecode.
	[true] whileTrue: [self dispatchOn: currentBytecode in: BytecodeTable].
	localIP _ localIP - 1.  "undo the pre-increment of IP before returning"
	self externalizeIPandSP.
! !


!Password methodsFor: 'as yet unclassified' stamp: 'jm 5/12/2000 22:37'!
serverPasswords
	"Get the server passwords off the disk and decode them. The file 'sqk.info' must be in the same folder as the Squeak application (VM) that is running this image. (Note: This code works even if you are running with no system sources file.)"

	| dir encodedPasswords |
	dir _ FileDirectory on: Smalltalk vmPath.
	(dir fileExists: 'sqk.info') ifFalse: [^ nil].	"Caller will ask user for password"
	encodedPasswords _ (dir oldFileNamed: 'sqk.info') contentsOfEntireFile.
		"If you don't have this file, and you really do want to release 
		an update, contact Ted Kaehler."
	^ (self decode: encodedPasswords) findTokens: String cr
! !

