'From Squeak2.8alpha of 12 January 2000 [latest update: #2203] on 23 May 2000 at 8:39:39 pm'!
"Change Set:		May23Tweaks
Date:			23 May 2000
Author:			Dan Ingalls

A couple of fixes for entries in Undeclared.
"!


!MailDB methodsFor: 'housekeeping' stamp: 'di 5/23/2000 20:38'!
findDuplicates
	"MailDB someInstance findDuplicates"
	| msgsAtTime duplicates msgsBySize similarMessages textCache first second text1 text2 |
	duplicates _ Set new.
	msgsAtTime _ ((self messagesIn: '.all.')
				collect: [:e | indexFile at: e])
				groupBy: [:e | e time]
				having: [:arr | arr size > 1].
	msgsAtTime
		associationsDo: 
			[:assoc | 
			msgsBySize _ assoc value groupBy: [:e | e textLength]
						having: [:arr | arr size > 1].
			msgsBySize
				associationsDo: 
					[:assoc2 | 
					similarMessages _ assoc2 value.
					textCache _ Dictionary new.
					similarMessages combinations: 2
						atATimeDo: 
							[:each | 
							first _ each first.
							second _ each second.
							((first likelyEqual: second)
								and: 
									[text1 _ textCache at: first msgID ifAbsentPut: [(self getMessage: first msgID) bodyText].
									text2 _ textCache at: second msgID ifAbsentPut: [(self getMessage: second msgID) bodyText].
									text1 = text2])
								ifTrue: [duplicates add: second msgID]]]].
	^ duplicates asArray! !

PasteUpMorph removeSelector: #convertToNewDragNDrop!
"Postscript:
Get rid of any obsolete WatchMrophs."
WatchMorph allInstancesDo: [:m | m delete]
!

