'From Squeak 2.1 of June 30, 1998 on 10 September 1998 at 8:34:28 am'!
"Change Set:		uiColorChange-sw
Date:			10 September 1998
Author:			Scott Wallace

Fixes long-standing bugs in colorUnder and colorSees, wherein the scripts were not getting recompiled after user picked a new color on a scripting tile"!


!Morph methodsFor: 'change reporting' stamp: 'sw 9/10/1998 08:18'!
colorChangedForSubmorph: aSubmorph
	"The color associated with aSubmorph was changed through the UI; react if needed"! !

!Morph methodsFor: 'change reporting' stamp: 'sw 9/10/1998 08:18'!
userSelectedColor: aColor
	"The user, via the UI, chose aColor to be the color for the receiver; set it, and tell my owner in case he wishes to react"
	self color: aColor.
	owner ifNotNil: [owner colorChangedForSubmorph: self]! !


!TileMorph methodsFor: 'misc' stamp: 'sw 9/10/1998 08:33'!
colorChangedForSubmorph: aSubmorph
	"Invoked when the user selects a new color on a colorTile or a color-seer-tile; need to recompile the script."
	self acceptNewLiteral! !


!ColorTileMorph methodsFor: 'events' stamp: 'sw 9/10/1998 08:22'!
mouseUp: evt
	evt hand changeColorTarget: colorSwatch selector: #userSelectedColor:! !


