'From Squeak2.9alpha of 12 June 2000 [latest update: #2594] on 10 September 2000 at 4:08:59 pm'!
"Change Set:		WnldHack-ar
Date:			10 September 2000
Author:			Andreas Raab

A hack for faster #containsPoint: in Wonderlands w/o backgrounds. Since on each morphic cycle there are between 3-6 sends of #containsPoint: and since a mouse event is generated on each morphic cycle (even if nothing whatsoever happens) this hack gives much better responsiveness.
"!

WonderlandMorph subclass: #WonderlandCameraMorph
	instanceVariableNames: 'myCamera myControls eventFocus lastCursorPoint mouseUpButton firstPersonControls mode outline currentActor currentPosition currentCanvas currentColor currentNib lastPosition paintMode palette restore backup pickedPoint pickedActor '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Balloon3D-Wonderland Morphs'!

!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 9/10/2000 16:04'!
drawOn: aCanvas 
	aCanvas asBalloonCanvas render: self.
	self outline ifNotNil: [self sketchOn: aCanvas].
	"*** hack ***"
	pickedPoint _ nil.! !

!WonderlandCameraMorph methodsFor: 'geometry' stamp: 'ar 9/10/2000 16:06'!
containsPoint: aPoint
	"Perform a full picking op if the camera does not draw the background"
	myCamera drawSceneBackground
		ifTrue:[^super containsPoint: aPoint].
	"*** hack ***"
	pickedPoint = aPoint 
		ifFalse:[pickedActor _ myCamera pickAt: aPoint].
	pickedPoint _ aPoint.
	^pickedActor notNil! !

!WonderlandCameraMorph methodsFor: 'stepping' stamp: 'ar 9/10/2000 16:04'!
step

	self changed.
	"*** hack ***"
	pickedPoint _ nil.! !

!WonderlandCameraMorph methodsFor: 'object fileIn' stamp: 'ar 9/10/2000 16:08'!
convertbosfcemmmelmfmoccccclpprb0: varDict bosfcemmmelmfmoccccclpprbpp0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'myWonderland' 'myCamera' 'myControls' 'eventFocus' 'lastCursorPoint' 'mouseUpButton' 'firstPersonControls' 'mode' 'outline' 'currentActor' 'currentPosition' 'currentCanvas' 'currentColor' 'currentNib' 'lastPosition' 'paintMode' 'palette' 'restore' 'backup').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('pickedPoint' 'pickedActor')  If a non-nil value is needed, please assign it."
! !

