'From Squeak2.9alpha of 12 June 2000 [latest update: #2593] on 10 September 2000 at 5:32:11 pm'!
"Change Set:		PolygonFixes
Date:			10 September 2000
Author:			Dan Ingalls

Installs proper conversion routines for polygons and curves created before changeSet 2575.

Undoes an earlier change so that shapes created as Curves will be instances of class Curve.  "!

!PolygonMorph methodsFor: 'object fileIn' stamp: 'RAA 9/9/2000 18:31'!
convertbosfcebbvcfqaahb0: varDict bosfcebbvcfaascpphb0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'vertices' 'closed' 'filledForm' 'arrows' 'arrowForms' 'handles' 'borderForm').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('smoothCurve' 'coeffs' 'ptAfterFirst' 'ptBeforeLast')  If a non-nil value is needed, please assign it."
	"These are going away #('quickFill').  Possibly store their info in another variable?"

	smoothCurve _ false.! !


!CurveMorph methodsFor: 'initialization' stamp: 'di 9/10/2000 14:28'!
initialize

	super initialize.
	self beSmoothCurve.
! !

!CurveMorph methodsFor: 'object fileIn' stamp: 'di 9/10/2000 17:32'!
convertbosfcebbvcfqaahbcnn0: varDict bosfcebbvcfaascpphbcnn0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'vertices' 'closed' 'filledForm' 'arrows' 'arrowForms' 'handles' 'borderForm' 'coefficients' 'ntfPoint' 'ntlPoint').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('smoothCurve' 'coeffs' 'ptAfterFirst' 'ptBeforeLast')  If a non-nil value is needed, please assign it."
	"These are going away #('quickFill').  Possibly store their info in another variable?"

	smoothCurve _ true.! !

CurveMorph class removeSelector: #new!
CurveMorph class removeSelector: #vertices:color:borderWidth:borderColor:!


