'From Squeak3.1alpha of 7 February 2001 [latest update: #3761] on 2 March 2001 at 10:54:39 am'!
"Change Set:		sysWindowStep-sw
Date:			2 March 2001
Author:			Scott Wallace

Fixes bugs that made players belonging to system windows not get sent the step message, and that made the attempt to bring a Viewer up on a Transcript window generate an error -- these were related!!"!


!SystemWindow methodsFor: 'stepping' stamp: 'sw 3/2/2001 10:19'!
step
	"Step the receiver.  Send it to the model, if the receiver is open and if it **has* a model"

	isCollapsed ifFalse:
		[model ifNotNil: [model stepIn: self].
		super step  "in case there is a Player who would like to be stepped"]! !

!SystemWindow methodsFor: 'stepping' stamp: 'sw 3/2/2001 10:31'!
stepAt: millisecondClockValue
	"Step the receiver at the given point in time.  Send it to the model, the receiver is open and if it **has* a model"

	isCollapsed ifFalse:
		[model ifNotNil: [model stepAt: millisecondClockValue in: self].
		super stepAt: millisecondClockValue "let player, if any, step"]! !


!TranscriptStream methodsFor: 'model protocol' stamp: 'sw 3/2/2001 10:18'!
step
	"Objects that may be models of SystemWindows need to respond to this, albeit vacuously"! !

