'From Squeak2.9alpha of 13 June 2000 [latest update: #3299] on 06 July 2001'!
"Change Set:		tinyMenu-je77
Date:			6 July 2001
Author:			Je77 Rick

Provides an improved menu icon for System Windows
(Tweaked by sw)"!

!SystemWindow methodsFor: 'initialization' stamp: 'je77 & sw 07/2001'!
addMenuControl
"If I have a label area, add a menu control to it. "

	| frame |
	labelArea ifNil: [^ self].  "No menu if no label area"
	menuBox _ IconicButton new borderWidth: 0;
			labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu'); color: Color transparent; 
			actWhen: #buttonDown;
			actionSelector: #offerWindowMenu; target: self;
			setBalloonText: 'window menu'.
	frame _ LayoutFrame new.
	frame leftFraction: 0; leftOffset: 17; topFraction: 0; topOffset: 1.
	menuBox layoutFrame: frame.
	labelArea addMorph: menuBox! !

"Postscript:
Replace the icon for TinyMenu"
ScriptingSystem saveForm: ((ColorForm
	extent: 12@9
	depth: 1
	fromArray: #( 0 2145386496 2145386496 1616904192 1616904192 1616904192 2145386496 2145386496 0)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #( )  )) atKey: 'TinyMenu'.!

