'From Squeak3.1alpha of 5 February 2001 [latest update: #4259] on 18 August 2001 at 12:59:56 pm'!
"Change Set:		zipCloseStream
Date:			18 August 2001
Author:			Bob Arning

Added #close of output stream when extracting all members in a zip archive"!


!ArchiveViewer methodsFor: 'archive operations' stamp: 'RAA 8/18/2001 12:58'!
extractAll
	| directory stream |

	self canExtractAll ifFalse: [^ self].
	[
		directory _ FileList2 modalFolderSelector ifNil: [^ self].
		(self extractAllPossibleInDirectory: directory) ifTrue: [
			self members do: [:ea | 
				ea isDirectory ifTrue: [
					[directory createDirectory: ea fileName allButLast]
						on: Error
						do: [:ex | 
							(PopUpMenu confirm: ea fileName , ' cannot be created. Continue?')
								ifFalse: [^ self]
						]
				] ifFalse: [
					(stream _ directory forceNewFileNamed: ea fileName) ifNil: [
						(PopUpMenu confirm: ea fileName , ' cannot be created. Continue?') 
							ifFalse: [^ self]
					] ifNotNil: [
						ea extractTo: stream. stream close
					]
				]
			].
			^ self
		].
		PopUpMenu confirm: 'Try again?'
	] whileTrue! !

