'From Squeak3.3alpha of 12 January 2002 [latest update: #4744] on 6 February 2002 at 2:27:09 am'!
"Change Set:		dontComeToFront-sw
Date:			6 February 2002
Author:			Scott Wallace

A recent change resulted in a damaging bug in the showing of textual source in Scriptors -- a mouse-over of the textual scripting pane moved the pane to the top of the scriptor, with disastrous results.  This update works around that."!


!MethodMorph methodsFor: 'scrolling' stamp: 'sw 2/6/2002 02:26'!
showScrollBar
	"Copied down and modified to get rid of the ruinous comeToFront of the inherited version."

	| scriptor |
	(submorphs includes: scrollBar)
		ifTrue: [^ self].
	self resizeScrollBar.
	self privateAddMorph: scrollBar atIndex: 1.
	retractableScrollBar
		ifTrue:
			["Bring the pane to the front so that it is fully visible"
			"self comeToFront. -- thanks but no thanks"
			(scriptor _ self ownerThatIsA: ScriptEditorMorph)
				ifNotNil:
					[scriptor comeToFront]]
		ifFalse: [self resetExtent]! !

