'From Squeak3.3alpha of 18 January 2002 [latest update: #4915] on 11 July 2002 at 3:13:53 pm'!
"Change Set:		loadEToys-sw
Date:			11 July 2002
Author:			Scott Wallace

Removes barriers to loading etoys into 3.3.  Caution: this update is for 3.3 only."!

!SmartRefStream methodsFor: 'import image segment' stamp: 'sw 7/11/2002 15:01'!
mapClass: newClass origName: originalName
	"See if instances changed shape.  If so, make a fake class for the old shape and return it.  Remember the original class name."

	| newName oldInstVars fakeClass |
	newClass isMeta ifTrue: [^ newClass].
	newName _ newClass name.
	(steady includes: newClass) & (newName == originalName) ifTrue: [^ newClass].
		"instances in the segment have the right shape"
	oldInstVars _ structures at: originalName ifAbsent:
		[self error: 'class is not in structures list'].	"Missing in object file"
	fakeClass _ Object subclass: ('Fake37', originalName) asSymbol
		instanceVariableNames: oldInstVars allButFirst
		classVariableNames: ''
		module: #(Squeak EToy UserObjects).
	Smalltalk changes removeClassChanges: fakeClass name.	"reduce clutter"
	^ fakeClass! !

