'From Squeak3.3alpha of 18 January 2002 [latest update: #4930] on 27 July 2002 at 2:09:40 pm'!
"Change Set:		versBrowFix-sw
Date:			27 July 2002
Author:			Scott Wallace

Fixes a glitch in update 4926 that only showed up when browsing versions of a method on the class side."!


!StringHolder methodsFor: 'message list menu' stamp: 'sw 7/27/2002 14:07'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the currently selected message."

	| selector class |
	(selector _ self selectedMessageName) ifNotNil:
		[(MessageSet isPseudoSelector: selector) ifTrue:  "Eliminates Comment, Definition, Hierarchy"
			[^ self inform: 'Sorry, only actual methods have retrievable versions.']. 
		class _ self selectedClassOrMetaClass.
		VersionsBrowser
			browseVersionsOf: (class compiledMethodAt: selector)
			class: self selectedClass
			meta: class isMeta
			category: (class organization categoryOfElement: selector)
			selector: selector]! !

