'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5184] on 18 May 2003 at 1:19:03 pm'!
"Change Set:		FloatPrecisionFix-nk
Date:			18 May 2003
Author:			Ned Konz

This fixes a problem that is caused when UpdatingStringMorph>>floatPrecision: is called with a number that is not a negative power of 10.

You can see this with 'Speaker manWithEditor'. 
"!


!Utilities class methodsFor: 'miscellaneous' stamp: 'nk 5/18/2003 13:03'!
decimalPlacesForFloatPrecision: precision
	"Answer the number of decimal places that correspond to the given floatPrecision"

	^ (#(1 0.1 0.01 0.001 0.0001 0.00001 0.000001 0.0000001 0.00000001 0.000000001) indexOf: precision ifAbsent: [ ^precision log negated floor ]) - 1

"
#(1 0.1 0.01 0.001 0.0001 0.00001 0.000001 0.0000001 0.00000001 0.000000001) collect: [:prec | Utilities decimalPlacesForFloatPrecision: prec]
"! !

