'From Squeak 2.3 of January 14, 1999 on 17 February 1999 at 1:58:33 pm'!
"Change Set:		prefsClosure-sw
Date:			17 February 1999
Author:			Scott Wallace

Tidies up a couple of ragged edges remaining after the recent prefs change."!

PasteUpMorph subclass: #WorldMorph
	instanceVariableNames: 'hands activeHand viewBox canvas damageRecorder stepList lastStepTime lastCycleTime '
	classVariableNames: 'DisableDeferredUpdates MinCycleLapse '
	poolDictionaries: ''
	category: 'Morphic-Kernel'!

!WorldMorph methodsFor: 'initialization' stamp: 'sw 2/16/1999 14:48'!
initialize

	super initialize.
	color _ (Color r:0.937 g: 0.937 b: 0.937).
	fillColor2 _ color.
	hands _ Array new.
	self addHand: HandMorph new.
	viewBox _ canvas _ nil.
	damageRecorder _ DamageRecorder new.
	stepList _ OrderedCollection new.
	lastStepTime _ 0.
	self setProperty: #automaticPhraseExpansion toValue: true.
	model _ nil.
! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 2/17/1999 14:05'!
noteThatFlag: prefSymbol justChangedTo: aBoolean
	"Provides a hook so that a user's toggling of a preference might precipitate some immediate action"
	"temporarily commented out pending flaps-pkg release
	((prefSymbol == #useFlaps) and: [Smalltalk isMorphic]) ifTrue:
		[aBoolean
			ifTrue:
				[self currentWorld addFlaps]
			ifFalse:
				[self currentWorld deleteAllFlapArtifacts]]"! !

Presenter removeSelector: #toggleShowBalloons!
Presenter removeSelector: #balloonHelpEnabled!
WorldMorph removeSelector: #toggleShowBalloons!
WorldMorph removeSelector: #convertbosfcepcbbfgccpmcpbttloiairfidcuwhavcdslplb0:bosfcepcbbfgccpmcpbttloiairfidcuwhavcdsllb0:!
WorldMorph removeSelector: #balloonHelpEnabled!
WorldMorph removeSelector: #convertbosfcepcbbfgccpmcpbttloiairfidcuwhavcdslpl0:bosfcepcbbfgccpmcpbttloiairfidcuwhavcdslplb0:!
WorldMorph removeSelector: #convertbosfcepcbbfgccpmcpbttloiairfidcuwhavcdslp0:bosfcebbfgccpmcpbttloiairfidcuwhavcdsllb0:!
