'From Squeak3.1alpha of 7 February 2001 [latest update: #3761] on 2 March 2001 at 10:54:45 am'!
"Change Set:		cardPlayer-sw
Date:			2 March 2001
Author:			Scott Wallace

Adds CardPlayer to the list of uniclass-name-stems used for enumerating and clobbering uniclasses in SystemCictionary.removeNormalCruft"!


!SystemDictionary methodsFor: 'shrinking' stamp: 'sw 3/2/2001 10:54'!
removeNormalCruft 
	"Remove various graphics, uniclasses, references.   Caution: see comment at bottom of method"

	"Smalltalk removeNormalCruft"
	
	ScriptingSystem stripGraphicsForExternalRelease.
	ScriptingSystem spaceReclaimed.
	References keys do: [:k | References removeKey: k].
	Smalltalk classNames do:
		[:cName | #( 'Player' 'CardPlayer' 'Component' 'WonderlandActor' 'MorphicModel' 'PlayWithMe') do:
			[:superName | ((cName ~= superName and: [cName beginsWith: superName])
				and: [(cName allButFirst: superName size) allSatisfy: [:ch | ch isDigit]])
				ifTrue: [Smalltalk removeClassNamed: cName]]].
	Smalltalk at: #Wonderland ifPresent:[:cls | cls removeActorPrototypesFromSystem].
	Smalltalk changes clear

"Caution: if any worlds in the image happen to have uniclass players associated with them, running this method would likely compromise their functioning and could cause errors, especially if the uniclass player of the current world had any scripts set to ticking.  If that happens to you somehow, you will probably want to find a way to reset the offending world's player to be an UnscriptedCardPlayer, or perhaps nil"
! !

