'From Squeak3.1alpha of 5 February 2001 [latest update: #3766] on 3 March 2001 at 3:06:57 pm'!
"Change Set:		appearanceBorders
Date:			3 March 2001
Author:			Bob Arning

added toggles for raised and inset borders to ObjectPropertiesMorph"!


!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/3/2001 14:57'!
targerBorderIsInset

	(targetMorph respondsTo: #borderColor) ifFalse: [^false].
	^targetMorph borderColor == #inset! !

!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/3/2001 14:57'!
targerBorderIsRaised

	(targetMorph respondsTo: #borderColor) ifFalse: [^false].
	^targetMorph borderColor == #raised! !

!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/3/2001 14:55'!
toggleTargetBorderInset

	(targetMorph respondsTo: #borderColor:) ifFalse: [^self].
	targetMorph borderColor: (
		targetMorph borderColor == #inset ifTrue: [Color black] ifFalse: [#inset]
	)! !

!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/3/2001 14:55'!
toggleTargetBorderRaised

	(targetMorph respondsTo: #borderColor:) ifFalse: [^self].
	targetMorph borderColor: (
		targetMorph borderColor == #raised ifTrue: [Color black] ifFalse: [#raised]
	)! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 3/3/2001 15:02'!
paneFor2ndGradientColorPicker

	^self 
		inAColumn: {
			(self inAColumn: {
				self colorPickerFor: self getter: #tgt2ndGradientColor setter: #tgt2ndGradientColor:.
				self lockedString: '2nd gradient color'.
				self paneForRadialGradientToggle hResizing: #shrinkWrap.
				(
					self inARow: {self paneForGradientOrigin. self paneForGradientDirection}
				) hResizing: #shrinkWrap.
			}
			named: #pickerFor2ndGradientColor) layoutInset: 0.
			self paneForGradientFillToggle hResizing: #shrinkWrap 
		}
! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 3/3/2001 15:00'!
paneForBorderColorPicker

	^self 
		inAColumn: {
			self colorPickerFor: self
			getter: #targetBorderColor
			setter: #targetBorderColor:.
			self lockedString: 'Border Color'.
			(self paneForBorderToggles)  hResizing: #shrinkWrap.
			self paneForBorderWidth.
		} 
		named: #pickerForBorderColor.

! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 3/3/2001 15:04'!
paneForBorderToggles

	^self inARow: {
		self
			directToggleButtonFor: self 
			getter: #targerBorderIsRaised setter: #toggleTargetBorderRaised
			help: 'Set a raised border'.
		self lockedString: ' Raised  '.
		self
			directToggleButtonFor: self 
			getter: #targerBorderIsInset setter: #toggleTargetBorderInset
			help: 'Set an inset border'.
		self lockedString: ' Inset'.
	}

! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 3/3/2001 15:00'!
paneForMainColorPicker

	^self 
		inAColumn: {
			self 
				colorPickerFor: self 
				getter: #numberOneColor 
				setter: #numberOneColor:.
			self lockedString: 'Color'.
			(self paneForSolidFillToggle)  hResizing: #shrinkWrap.
		} 
		named: #pickerForColor.

! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 3/3/2001 15:03'!
paneForShadowColorPicker

	^self 
		inAColumn: {
			(self inAColumn: {
				self colorPickerFor: targetMorph getter: #shadowColor setter: #shadowColor:.
				self paneForShadowOffset.
			}
			named: #pickerForShadowColor) layoutInset: 0.
			self paneForDropShadowToggle hResizing: #shrinkWrap.
		}

! !

