'From Squeak3.1alpha of 28 February 2001 [latest update: #3874] on 24 March 2001 at 10:56:44 pm'!
"Change Set:		tilesFix-sw
Date:			24 March 2001
Author:			Scott Wallace

Fixes bug that could make tile-bearing panes in browsers continually refresh."!


!CodeHolder methodsFor: 'tiles' stamp: 'sw 3/24/2001 22:45'!
installTilesForSelection
	"Install universal tiles into the code pane."

	| source aSelector aClass tree syn tileScriptor aWindow codePane |
	(aWindow _ self containingWindow) ifNil: [self error: 'hamna dirisha'].
	tileScriptor _  (aSelector _ self selectedMessageName)
		ifNil:
			[PluggableTileScriptorMorph new]
		ifNotNil:
			[aClass _ self selectedClassOrMetaClass classThatUnderstands:  aSelector.
			source _ aClass sourceCodeAt: aSelector.    
			tree _ Compiler new 
				parse: source 
				in: aClass 
				notifying: nil.
			(syn _ tree asMorphicSyntaxUsing: SyntaxMorph)
				parsedInClass: aClass.
			syn inAPluggableScrollPane].
	codePane _ aWindow findDeepSubmorphThat:   
		[:m | ((m isKindOf: PluggableTextMorph) and: [m getTextSelector == #contents]) or:
			[m isKindOf: PluggableTileScriptorMorph]] ifAbsent: [self error: 'no code pane'].
	tileScriptor color: aWindow paneColorToUse;
		setProperty: #hideUnneededScrollbars toValue: true;
		setProperty: #maxAutoFitSize toValue: codePane owner extent.
	aWindow replacePane: codePane with: tileScriptor.
	currentCompiledMethod _ aClass compiledMethodAt: aSelector.
	tileScriptor owner clipSubmorphs: true.
	tileScriptor extent: codePane extent.! !

