"Change Set:		threadSafe
Date:			26 April 2001
Author:			Michael Rueger, Andreas Raab

Makes the Transcript thread safe.
A fix that got lost for a year... ;-)
"!

WriteStream subclass: #TranscriptStream
	instanceVariableNames: ''
	classVariableNames: 'AccessSema '
	poolDictionaries: ''
	category: 'Collections-Streams'!

!TranscriptStream methodsFor: 'private' stamp: 'mir 1/11/2000 11:41'!
semaphore
	^AccessSema ifNil:[AccessSema _ Semaphore forMutualExclusion]! !


!TranscriptStream methodsFor: 'stream extensions' stamp: 'mir 1/11/2000 11:41'!
endEntry
	"Display all the characters since the last endEntry, and reset the stream"
	self semaphore critical:[
		self changed: #appendEntry.
		self reset.
	].! !



