'From Squeak3.1alpha of 28 February 2001 [latest update: #4009] on 10 May 2001 at 9:33:29 pm'!
"Change Set:		EtoyInstVarFix-ar
Date:			10 May 2001
Author:			Andreas Raab

A quick fix for the inability to create instance variables in eToys. I'm unsure if that fix is really a fix for the problem and not for the symptom, but it certainly does the trick."!


!Player methodsFor: 'slots-kernel' stamp: 'ar 5/10/2001 21:31'!
methodInterfacesForInstanceVariablesCategoryIn: aViewer
	"Return a collection of methodInterfaces for the instance-variables category"

	| aList anInterface itsSlotName |
	aList _ OrderedCollection new.
	self slotInfo associationsDo:
		[:assoc |
			anInterface _ MethodInterface new.
			itsSlotName _ assoc key.

			anInterface wording: itsSlotName selector: (Utilities getterSelectorFor: itsSlotName) type: assoc value type setter: (Utilities setterSelectorFor: itsSlotName).
			anInterface setToRefetch.
			aList add: anInterface].
	^ aList! !

