'From Squeak3.1alpha of 28 February 2001 [latest update: #4009] on 11 May 2001 at 12:29:11 am'!
"Change Set:		instVarFix-sw
Date:			11 May 2001
Author:			Scott Wallace

Fixes a bug in the etoy system that neglected to make user-added inst vars be read/write"!


!Player methodsFor: 'slots-kernel' stamp: 'sw 5/11/2001 00:19'!
methodInterfacesForInstanceVariablesCategoryIn: aViewer
	"Return a collection of methodInterfaces for the instance-variables category"

	| aList anInterface itsSlotName |
	aList _ OrderedCollection new.
	self slotInfo associationsDo:
		[:assoc |
			anInterface _ MethodInterface new.
			itsSlotName _ assoc key.

			anInterface wording: itsSlotName selector: (Utilities getterSelectorFor: itsSlotName) type: assoc value type setter: (Utilities setterSelectorFor: itsSlotName).
			anInterface setToRefetch.
			aList add: anInterface].
	^ aList! !

