'From Squeak3.1alpha of 23 February 2001 [latest update: #4282] on 28 August 2001 at 9:13:51 pm'!
"Change Set:		BlobFix-ccn
Date:			28 August 2001
Author:			Chris Norton

This covers up a bug with BlobMorph and the new Objects viewer.  In my opinion, the bug I'm covering up just obscures an example of how class variables should not be used.  However, I decided to slap a band-aid on this one, rather than to re-implement BlobMorphs!!"!


!BlobMorph methodsFor: 'stepping' stamp: 'ccn 8/28/2001 20:51'!
mergeBlobs
	"See if we need to merge by checking our bounds against all other Blob
	bounds, then all our vertices against any Blob with overlapping bounds.
	If we find a need to merge, then someone else does all the work."

	(AllBlobs isNil or: [AllBlobs size < 2]) 
		ifTrue: [^ self].
	AllBlobs
		do:
			[:aBlob |
			aBlob owner == self owner ifTrue:
				[(self bounds intersects: aBlob bounds) ifTrue:
					[vertices do:
						[:aPoint |
						(aBlob containsPoint: aPoint) ifTrue:
							[^ self mergeSelfWithBlob: aBlob atPoint: aPoint]]]]]
		without: self! !

