'From Squeak3.1alpha of 28 February 2001 [latest update: #4406] on 2 October 2001 at 4:33:32 pm'!
"Change Set:		FixPaneColors-ar
Date:			2 October 2001
Author:			Andreas Raab

Fixes the lighter pane colors introduced by CS 4399 to work correctly. The CS had changed all the panes independently which had implications for any sub-pane dividers not showing the right colors. Besides ... why change all the panes individually if we can just change the color of the entire damn system window, eh?!!"!


!SystemWindow methodsFor: 'panes' stamp: 'ar 8/15/2001 23:29'!
addMorph: aMorph fullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs _ paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	Preferences alternativeWindowLook ifFalse:[
		aMorph borderWidth: 1.
		aMorph color: self paneColor.
	] ifTrue:[
		aMorph borderWidth: 2; borderColor: #inset; color: Color transparent.
	].! !

!SystemWindow methodsFor: 'panes' stamp: 'ar 10/2/2001 16:29'!
paneColor: aColor
	self setProperty: #paneColor toValue: aColor.
	(Preferences alternativeWindowLook and:[aColor notNil]) 
		ifTrue:[self color: aColor veryMuchLighter]! !

