'From Squeak3.2alpha of 14 October 2001 [latest update: #4518] on 2 December 2001 at 3:18:17 pm'!
"Change Set:		mailAddrParser-ls
Date:			2 December 2001
Author:			Lex Spoon

Fixes the Internet mail address parser.  A couple of character sets were incorrect in the tokenizer, and hopefully they are correct now.  At least 'MailAddressParser example' works now!!"!


!MailAddressTokenizer class methodsFor: 'class initialization' stamp: 'ls 12/2/2001 15:15'!
initialize
	"Initalize class variables using   MailAddressTokenizer initialize"

	| atomChars |

	CSParens _ CharacterSet empty.
	CSParens addAll: '()'.

	CSSpecials _ CharacterSet empty.
	CSSpecials addAll: '()<>@,;:\".[]'.

	CSNonSeparators _ CharacterSet separators complement.


	"(from RFC 2822)"
	atomChars := CharacterSet empty.
	atomChars addAll: ($A to: $Z).
	atomChars addAll: ($a to: $z).
	atomChars addAll: ($0 to: $9).
	atomChars addAll: '!!#$%^''*+-/=?^_`{|}~'.

	CSNonAtom :=  atomChars complement.! !

MailAddressTokenizer initialize!
