'From Squeak3.3alpha of 18 January 2002 [latest update: #4938] on 1 August 2002 at 4:14:11 pm'!
"Change Set:		assureRecent-sw
Date:			1 August 2002
Author:			Scott Wallace

Fixes the serious performance bug that if the method most recently submitted to the system subsequently got removed, recent-submissions browsers would continuously recompute their message lists."!


!Utilities class methodsFor: 'recent method submissions' stamp: 'sw 7/29/2002 02:18'!
assureMostRecentSubmissionExists
	"Make certain that the most recent submission exists"

	[RecentSubmissions size > 0 and:
		[RecentSubmissions last isValid not]] whileTrue:
			[RecentSubmissions removeLast].! !

!Utilities class methodsFor: 'recent method submissions' stamp: 'sw 7/29/2002 02:12'!
mostRecentlySubmittedMessage
	"Answer a string indicating the most recently submitted method that is still extant"

	self flag: #mref.	"fix for faster references to methods"

	self assureMostRecentSubmissionExists.
	^ RecentSubmissions last asStringOrText asString! !

