'From Squeak3.4alpha of 6 November 2002 [latest update: #5105] on 12 November 2002 at 1:43:34 pm'!
"Change Set:		spawnHierarchyFix-nk
Date:			12 November 2002
Author:			Ned Konz

Fixes the bug that spawning a hierarchy browser when a class definition was showing in a browser could generate an error.  

(Ned's fix integrated with 3.4a by Scott Wallace)"!


!CodeHolder methodsFor: 'commands' stamp: 'sw 11/12/2002 13:41'!
spawnHierarchy
	"Create and schedule a new hierarchy browser on the currently selected class or meta."

	| newBrowser aSymbol aBehavior messageCatIndex selectedClassOrMetaClass |
	(selectedClassOrMetaClass _ self selectedClassOrMetaClass)
		ifNil: [^ self].
	newBrowser _ HierarchyBrowser new initHierarchyForClass: selectedClassOrMetaClass.
	((aSymbol _ self selectedMessageName) notNil and: [(MessageSet isPseudoSelector: aSymbol) not])
		ifTrue:
			[aBehavior _ selectedClassOrMetaClass.
			messageCatIndex _ aBehavior organization numberOfCategoryOfElement: aSymbol.
			newBrowser messageCategoryListIndex: messageCatIndex + 1.
			newBrowser messageListIndex:
				((aBehavior organization listAtCategoryNumber: messageCatIndex) indexOf: aSymbol)].
	Browser
		openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: newBrowser labelString.
	Smalltalk isMorphic
		ifTrue: ["this workaround only needed in morphic"
			newBrowser assureSelectionsShow]! !

