'From Squeak3.4alpha of 6 November 2002 [latest update: #5125] on 22 November 2002 at 5:54:24 pm'!
"Change Set:		commentFix-sw
Date:			22 November 2002
Author:			Scott Wallace

Fixes the bug (reported by Bijan Parsia) that made a class comment seen in a browser continuously revert to unscrolled state when the user had switched from browsing on the class-side to browsing a class comment" !


!Browser methodsFor: 'class functions' stamp: 'sw 11/22/2002 17:50'!
editComment
	"Retrieve the description of the class comment."

	classListIndex = 0 ifTrue: [^ self].
	self okToChange ifFalse: [^ self].
	self messageCategoryListIndex: 0.
	editSelection _ #editComment.
	metaClassIndicated _ false.
	self changed: #classSelectionChanged.
	self decorateButtons.
	self contentsChanged! !

!Browser methodsFor: 'class functions' stamp: 'sw 11/22/2002 17:49'!
plusButtonHit
	"Cycle among definition, comment, and hierachy"

	editSelection == #editComment
		ifTrue: [self hierarchy. ^ self].
	editSelection == #hierarchy
		ifTrue: [editSelection := #editClass.
			classListIndex = 0 ifTrue: [^ self].
			self okToChange ifFalse: [^ self].
			self changed: #editComment.
			self contentsChanged.
			^ self].
	self editComment! !

