'From Squeak3.6beta of ''4 July 2003'' [latest update: #5373] on 5 August 2003 at 11:44:15 am'!
"Change Set:		HaltNotAnError-ajh
Date:			5 August 2003
Author:			Anthony Hannan

Halt was being treated as a special case in Exception class >> #handles: to avoid being handled by error handlers.  This changeset removes Halt as a subclass of Error making it an indendent exception class (direct subclass of Exception), and removes the special case test from #handles:."!

Exception subclass: #Halt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Exceptions Extensions'!

!Exception class methodsFor: 'exceptionSelector' stamp: 'ajh 8/5/2003 11:33'!
handles: exception
	"Determine whether an exception handler will accept a signaled exception."

	^ exception isKindOf: self! !


!Halt methodsFor: 'priv handling' stamp: 'ajh 8/5/2003 11:30'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	UnhandledError signalForException: self! !

Halt class removeSelector: #handles:!
