'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5604] on 12 December 2003 at 3:11:23 pm'!
"Change Set:		CleanupUpdateServers-dew
Date:			9 December 2003
Author:			Doug Way

Remove uiuc update url (from Utilities class>>updateUrlLists) which has been defunct for a long time.  Also clean up various other ServerDirectory update servers.  This includes removing the internal/SqC/test update servers; they can be handled with the changeset that adds internal/SqC update visibility."

| publicUpdateServers serversToRemove theinternetoneServer |
"Remove uiuc update url.  Only the squeakfoundation (internetone) updateUrl will exist as a public (non-European) updateUrl."
publicUpdateServers _ Utilities updateUrlLists detect: [:ea | ea first = 'Squeak Public Updates'] ifNone: [nil].
publicUpdateServers ifNotNil: [publicUpdateServers at: 2 put: {'update.squeakfoundation.org/external/'}].

"Remove all internal/SqC and internetone servers"
serversToRemove _ (ServerDirectory serversInGroupNamed: 'SqC Internal Updates*') asOrderedCollection.
serversToRemove addAll:
	(ServerDirectory servers values asOrderedCollection select: [:ea | ea server = 'ftp.theinternetone.net']).
ServerDirectory servers
	keysAndValuesRemove: [:key :value | serversToRemove includes: value].

"Re-add only the public theinternetone server"
theinternetoneServer _ ServerDirectory new.
theinternetoneServer
	server: 'ftp.theinternetone.net';
	directory: 'html/external/updates';
	type: #ftp;
	user: 'jto19449';
	groupName: 'Squeak Public Updates';
	altUrl: 'http://update.squeakfoundation.org/external/'.
ServerDirectory addServer: theinternetoneServer named: 'UpdatesAtSqF'.

"Remove various other obsolete update servers"
ServerDirectory removeServerNamed: 'UpdatesExtUIUC' ifAbsent: [].
ServerDirectory removeServerNamed: 'UpdatesExtUIUC2' ifAbsent: [].
ServerDirectory removeServerNamed: 'UpdatesAtSqueak.org' ifAbsent: [].
!

