'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 4 June 2004 at 6:33:11 pm'!
"Change Set:		explainInstFix-5905
Date:			4 June 2004
Author:			Tim

Whilst attempting an 'explain' on an instvar of NewParagraph, it seems
#browseAllAccessesTo: is not implemented. This appears to be still more
fallout from the KCP stuff since #browseAllAccessesTo:from: is
implemented and used.
Most likely the solution is to change the ParagraphEditor>explainInst:
method. Possible version attached."!


!ParagraphEditor methodsFor: 'explain' stamp: 'tpr 5/12/2004 16:22'!
explainInst: string 
	"Is string an instance variable of this class?"
	| classes cls |

	(model respondsTo: #selectedClassOrMetaClass) ifTrue: [
		cls _ model selectedClassOrMetaClass].
	cls ifNil: [^ nil].	  "no class known"
	classes _ (Array with: cls)
				, cls allSuperclasses.
	classes _ classes detect: [:each | (each instVarNames
			detect: [:name | name = string] ifNone: [])
			~~ nil] ifNone: [^nil].
	classes _ classes printString.
	^ '"is an instance variable of the receiver; defined in class ' , classes , 
		'"\' withCRs , classes , ' systemNavigation browseAllAccessesTo: ''' , string , ''' from: ', classes, '.'! !

