'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 19 July 2004 at 4:09:40 pm'!
"Change Set:		CleanUpUnimplemented-md
Date:			19 July 2004
Author:			Marcus Denker


This changes SystemNavigation>>unimplemend to return all unimplemented
methods found. (see tims bugreport).


Original Bugreport by tim: Tim wrote:

Subject:		[BUG]SystemNavigation>unimplemented
Author:		Tim Rowledge
Date Posted: 27 June 2003
Archive ID: 10817
Comments:	When  see comments like
	remove some clutter from the result:
	#(DoItIn: primitiveFail diffedVersionContents uniformWindowColors macOptionKeyAllowed)
		do: [:sel | unimplemented removeKey: sel ifAbsent: []].

and

	these messages are not sent when running on the Zaurus:
	#(channelData defaultAALevel: from:title: fromWaveFileNamed: imageFormOfSize:forFrame:
invokeAt:in: loadedFrames originalSamplingRate printInstructionsOn: processFile
readFrom:mergeIfStereo:skipDataChunk: samples samples:samplingRate: samplesRemaining
storeAIFFSamples:samplingRate:on: windowMenuWithLabels:colorPattern:targets:selections:title:)
		do: [:sel | unimplemented removeKey: sel ifAbsent: []].

I get a bit concerned that personally hacked up methods have been
wrongly released to the public. I could be wrong of course.
"!




!SystemNavigation methodsFor: 'query' stamp: 'md 7/19/2004 16:03'!
unimplemented
	"Answer an Array of each message that is sent by an expression in a method but is not implemented by any object in the system."

	| all unimplemented entry |
	all _ IdentitySet new: Symbol instanceCount * 2.
	Cursor wait showWhile: 
		[self allBehaviorsDo: [:cl | cl selectorsDo: [:aSelector | all add: aSelector]]].

	unimplemented _ IdentityDictionary new.
	Cursor execute showWhile: [
		self allBehaviorsDo: [:cl |
			 cl selectorsDo: [:sel |
				(cl compiledMethodAt: sel) messages do: [:m |
					(all includes: m) ifFalse: [
						entry _ unimplemented at: m ifAbsent: [Array new].
						entry _ entry copyWith: (cl name, '>', sel).
						unimplemented at: m put: entry]]]]].
	^ unimplemented
! !

