'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5989] on 16 September 2004 at 7:30:55 pm'!
"Change Set:		BitBlt
Date:			16 September 2004
Author:			Karl

Hi,

I got Squeak to freeze when I run Balloon3D in a combination
of the autoAccessor Preference and direct hardware accelearation
using Squeak3.7Gamma#5983 updated with to a FullImage to get Balloon3D. 

The problem is B3DHardwareEngine>>restoreMorphicForeground:above:
which sends #halftoneForm: to a BitBlt instance. But there is no
accessor method with this name.

To reproduce:

1. disable the squeak preference for autoAccessors
2. Evaluate 'B3DSceneExplorerMorph new openInWorld'
3. select 'Enable hardware accelaration' in the morph
4. Try to open a halo on the morph

It can easily be fixed if the accessor #halftoneForm: is added to BitBlt 
(additionally adding #halftoneForm for consistency). I would vote for 
adding this fix to the basic Squeak image even if it currently only
affects Balloon3D and my be packaged with it.

Bye
Torsten
"!


!BitBlt methodsFor: 'accessing' stamp: 'tbn 9/14/2004 20:38'!
halftoneForm
	"Returns the receivers half tone form. See class commment."
	
	^halftoneForm! !

!BitBlt methodsFor: 'accessing' stamp: 'tbn 9/14/2004 20:39'!
halftoneForm: aBitmap
	"Sets the receivers half tone form. See class commment."
	
	halftoneForm := aBitmap
	
 ! !

