'From Small-Land 3.8-5976-0266 of 2 September 2004 [latest update: #5976] on 7 September 2004 at 12:01:58 am'!
"Change Set:		DecorationMenuFix-dgd
Date:			7 September 2004
Author:			Diego Gomez Deck

Decorate the menu items only if they don't have an icon.  In this way we can fix an specific icon for an item.
"!


!MenuIcons class methodsFor: 'menu decoration' stamp: 'dgd 9/6/2004 23:53'!
decorateMenu: aMenu 
	"decorate aMenu with icons"
	| numberAdded |
	Preferences menuWithIcons
		ifFalse: [^ self].
	numberAdded := 0.
	aMenu items do: [ :item | | icon |
		item icon isNil ifTrue:[
			icon _ self iconForMenuItem: item.
			icon ifNotNil: [
				item icon: icon.
				numberAdded := numberAdded + 1. ]]].

	numberAdded isZero ifTrue: [^ self].
	aMenu addBlankIconsIfNecessary: self blankIcon! !

