'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 3 September 2004 at 7:36:03 pm'!
"Change Set:		ProjectViewMorphInWindowFix
Date:			3 September 2004
Author:			Karl Ramberg

ImageMorphs gets their borderWidth added to their extent, unlike other morphs. This is a small fix to check whether a ImageMorph is added to a SystemWindow and make sure it does not get a border added."!


!SystemWindow methodsFor: 'panes' stamp: 'kfr 9/3/2004 19:27'!
addMorph: aMorph fullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs _ paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	Preferences alternativeWindowLook
		ifFalse:
			[aMorph borderWidth: 1.
			aMorph color: self paneColor]
		ifTrue:
		    [(aMorph isKindOf: ImageMorph) ifFalse:[
			aMorph adoptPaneColor: self paneColor.
			aMorph borderWidth: 2; borderColor: #inset; color: Color transparent]].
	Preferences scrollBarsOnRight	"reorder panes so flop-out right-side scrollbar is visible"
		ifTrue: [self addMorphBack: aMorph]! !

