'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #336] on 8 October 2004 at 8:52:37 am'!
"Change Set:		fenceSound
Date:			8 October 2004
Author:			Michael Rueger

Disables the fence sound and adds a silent error handler if setting the mac file type for a project fails."!


!FileDirectory methodsFor: 'file operations' stamp: 'mir 10/8/2004 08:51'!
upLoadProject: projectFile named: destinationFileName resourceUrl: resUrl retry: aBool
	"Copy the contents of the existing fileStream into the file destinationFileName in this directory.  fileStream can be anywhere in the fileSystem.  No retrying for local file systems."

	| result |
	result _ self putFile: projectFile named: destinationFileName.
	[self
		setMacFileNamed: destinationFileName
		type: 'SOBJ'
		creator: 'FAST']
		on: Error
		do: [ "ignore" ].
	^result! !

"Postscript:
"
Preferences disable: #fenceSoundEnabled.
!

