'From Squeak3.9alpha of ''2 November 2004'' [latest update: #6474] on 28 November 2004 at 9:12:21 pm'!
"Change Set:		MultiCharacterFix
Date:			26 November 2004
Author:			Boris Gaertner

md: incorporated a change in asUnicode that was done

Methods asUnicode and asUnicodeChar compare a class to a metaclass. This change set fixes that mistake."!


!MultiCharacter methodsFor: 'converting' stamp: 'md 11/28/2004 21:10'!
asUnicode

	| table charset v |
	self leadingChar = 0 ifTrue: [^ value].
	charset _ EncodedCharSet charsetAt: self leadingChar.
	(charset isKindOf: EncodedCharSet) ifFalse: [^ self charCode].
	table _ charset ucsTable.
	table isNil ifTrue: [^ 16rFFFD].

	v _ table at: self charCode + 1.
	v = -1 ifTrue: [^ 16rFFFD].

	^ v.
! !

!MultiCharacter methodsFor: 'converting' stamp: 'BG 11/26/2004 15:20'!
asUnicodeChar

	| table charset v |
	charset _ EncodedCharSet charsetAt: self leadingChar.
	(charset isKindOf: Unicode) ifTrue: [^ self].
	table _ charset ucsTable.
	table isNil ifTrue: [^ Character value: 16rFFFD].

	v _ table at: self charCode + 1.
	v = -1 ifTrue: [^ Character value: 16rFFFD].

	^ MultiCharacter leadingChar: charset unicodeLeadingChar code: v.
! !

