'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6493] on 4 December 2004 at 10:49:35 pm'!
"Change Set:		charsetCheckAgain
Date:			4 December 2004
Author:			Yoshiki Ohshima

An attempt to change the way the inclusion test is done.  Boris Gaertner's suggestion aboud Unicode class is included."!


!EncodedCharSet class methodsFor: 'class methods' stamp: 'yo 12/2/2004 16:13'!
isCharset

	^ true.
! !


!LanguageEnvironment class methodsFor: 'accessing' stamp: 'yo 12/2/2004 16:13'!
isCharset

	^ false.
! !


!MultiCharacter methodsFor: 'converting' stamp: 'yo 12/2/2004 16:13'!
asUnicode

	| table charset v |
	self leadingChar = 0 ifTrue: [^ value].
	charset _ EncodedCharSet charsetAt: self leadingChar.
	charset isCharset ifFalse: [^ self charCode].
	table _ charset ucsTable.
	table isNil ifTrue: [^ 16rFFFD].

	v _ table at: self charCode + 1.
	v = -1 ifTrue: [^ 16rFFFD].

	^ v.
! !

!MultiCharacter methodsFor: 'converting' stamp: 'yo 12/2/2004 16:16'!
asUnicodeChar

	| table charset v |
	self leadingChar = 0 ifTrue: [^ value].
	charset _ EncodedCharSet charsetAt: self leadingChar.
	charset isCharset ifFalse: [^ self].
	table _ charset ucsTable.
	table isNil ifTrue: [^ Character value: 16rFFFD].

	v _ table at: self charCode + 1.
	v = -1 ifTrue: [^ Character value: 16rFFFD].

	^ MultiCharacter leadingChar: charset unicodeLeadingChar code: v.
! !


!Unicode class methodsFor: 'class methods' stamp: 'yo 12/4/2004 22:47'!
isCharset

	^ false.
! !

