'From Squeak3.8beta of ''2 November 2004'' [latest update: #6465] on 14 December 2004 at 12:50:35 pm'!
"Change Set:		SharedPoolSpelling-tpr
Date:			14 December 2004
Author:			tim@sumeru.stanford.edu

Mantis bug #666.
A hopefully temporary fix for a correct-the-spelling problem when SharedPools are used. Since they are not dictionaries, the #keysDo: method is not really appropriate but it solves the problem pro-tempore"!


!SharedPool class methodsFor: 'enumerating' stamp: 'tpr 12/14/2004 12:34'!
keysDo: aBlock
"A hopefully temporary fix for an issue arising from miss-spelled variable names in code being compiled. The correction code (see Class>possibleVariablesFor:continuedFrom: assumes that sharedPools are Dictionaries. The proper fix would involve making sure all pools are actually subclasses of SharedPool, which they are not currently."
	self bindingsDo:[:b|
		aBlock value: b key]! !
