'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6597] on 4 March 2005 at 1:28:51 pm'!
"Change Set:		loadUpdates-mir
Date:			4 March 2005
Author:			Michael Rueger, Goran Krampe

Change the auto start mechanism's update loading to suggest loading updates in a release image. 
If the preference #updateFromServerAtStartup is set (it would be in a release image) the user is prompted if he/she wants to check for updates. There is now a third option to disable that option for later starts."!


!AutoStart class methodsFor: 'updating' stamp: 'mir 3/4/2005 10:52'!
processUpdates
	"Process update files from a well-known update server.  This method is called at system startup time,   Only if the preference #updateFromServerAtStartup is true is the actual update processing undertaken automatically"

	(Preferences valueOfFlag: #updateFromServerAtStartup)
		ifTrue: [
			| choice |
			choice _ (PopUpMenu labels: 'Yes, Update\No, Not now\Don''t ask again' withCRs)
				startUpWithCaption: 'Do you want to check for updates\or maintenance fixes on the server?' withCRs.
			choice = 1 ifTrue: [Utilities updateFromServer].
			choice = 3 ifTrue: [
				Preferences setPreference: #updateFromServerAtStartup toValue: false.
				self inform: 'Remember to save you image to make this setting permant.'].
		].
	^false! !

