'From Squeakland.396-Nihongo7.29 of 14 March 2005 [latest update: #66] on 17 March 2005 at 4:02:49 pm'!
"Change Set:		recolorHelp-yo
Date:			17 March 2005
Author:			Yoshiki Ohshima

The balloon help for recolor handle should be changed based on the preference."!


!Morph methodsFor: 'halos and balloon help' stamp: 'yo 3/17/2005 16:01'!
balloonHelpTextForHandle: aHandle
	"Answer a string providing balloon help for the given halo handle"

	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(addFullHandles							'More halo handles')
		(addSimpleHandles						'Fewer halo handles')
		(chooseEmphasisOrAlignment				'Emphasis & alignment')
		(chooseFont								'Change font')
		(chooseNewGraphicFromHalo				'Choose a new graphic')
		(chooseStyle								'Change style')
		(dismiss									'Remove')
		(doDebug:with:							'Debug (press shift to inspect morph)')
		(doDirection:with:						'Choose forward direction')
		(doDup:with:							'Duplicate')
		(doDupOrMakeSibling:with: 				'Duplicate (press shift to make a sibling)')
		(doMakeSiblingOrDup:with: 				'Make a sibling (press shift to make simple duplicate)')
		(doMakeSibling:with: 					'Make a sibling')
		(doMenu:with:							'Menu')
		(doGrab:with:							'Pick up')
		(editButtonsScript						'See the script for this button')
		(editDrawing							'Repaint')
		(maybeDoDup:with:						'Duplicate')
		(makeNascentScript						'Make a scratch script')
		(makeNewDrawingWithin				'Paint new object')
		(mouseDownInCollapseHandle:with:		'Collapse')
		(mouseDownOnHelpHandle:				'Help')
		(openViewerForArgument				'Open a Viewer for me')
		(openViewerForTarget:with:				'Open a Viewer for me')
		(paintBackground						'Paint background')
		(prepareToTrackCenterOfRotation:with:	'Move object or set center of rotation')
		(presentViewMenu						'Present the Viewing menu')
		(startDrag:with:							'Move')
		(startGrow:with:							'Change size (press shift to preserve aspect)') 
		(startRot:with:							'Rotate')
		(startScale:with:							'Change scale') 
		(tearOffTile								'Make a tile representing this object')
		(tearOffTileForTarget:with:				'Make a tile representing this object')
		(trackCenterOfRotation:with:				'Set center of rotation')) 


	do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].

	(itsSelector == #mouseDownInDimissHandle:with:) ifTrue:
		[^ Preferences preserveTrash
			ifTrue:
				['Move to trash']
			ifFalse:
				['Remove from screen']].

	(itsSelector == #doRecolor:with:) ifTrue: [
		^ Preferences propertySheetFromHalo
			ifTrue: ['Property Sheet (press shift for simple recolor)']
			ifFalse: ['Change color (press shift for more properties)']].

	^ 'unknown halo handle'! !

"Postscript:
"
Preferences setPreference: #propertySheetFromHalo toValue: true.
!

