'From Squeak3.9alpha of 4 July 2005 [latest update: #7046] on 22 July 2006 at 10:56:08 am'!
"Change Set:		condenseSources-md
Date:			22 July 2006
Author:			Marcus Denker

Fix from 
0003433: MultiByteFileStream screws up default text converter if file name = sources name
The postcript then does a condenseSources. 

Important: We need to have opended the old sources file using MacRoman, but the new
one using a UTF encoder. We get this by fixing the file opening to not hard-code a
MacRoman encoder for .source, but we don't restart the image. Thus the old sources
are read using MacRoman, new ones are written using UTF8. I think. At least it works ;-)"!


!MultiByteFileStream methodsFor: 'open/close' stamp: 'md 7/20/2006 11:05'!
open: fileName forWrite: writeMode 
	| result |
	result := super open: fileName forWrite: writeMode.
	result ifNotNil: [
			converter ifNil: [converter := UTF8TextConverter new].
			self detectLineEndConvention].
	^result! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Smalltalk condenseSources.
SystemVersion current version: 'Squeak3.9gamma'; date: '23 July 2006'.
self inform: 'The version number for this image has
now been advanced to Squeak3.9gamma.'!

