'From Squeak3.9 of 7 November 2006 [latest update: #7067] on 28 June 2007 at 8:11:28 am'!
"Change Set:		7069ConvertTo3dot10
Date:			10 March 2007
Author:			Edgar J. De Cleene

Add the 3.10 Repository, look for last ReleaseBuilder , load and run>.
Also here I add some fixes for all work"

!


!Flaps class methodsFor: 'flaps registry' stamp: 'edc 12/9/2006 09:23'!
defaultsQuadsDefiningWidgetsFlap
	"Answer a structure defining the default Widgets flap.
     previously in quadsDefiningWidgetsFlap"

	^ #(
	(TrashCanMorph			new						'Trash'				'A tool for discarding objects')
	(AllScriptsTool			allScriptsToolForActiveWorld	'All Scripts' 		'A tool that lets you see and control all the running scripts in your project')
	(PaintInvokingMorph	new						'Paint'				'Drop this into an area to start making a fresh painting there')
	(GeeMailMorph			new						'Gee-Mail'			'A place to present annotated content')
	(RecordingControlsMorph	authoringPrototype		'Sound'				'A device for making sound recordings.')
	"(MPEGMoviePlayerMorph	authoringPrototype		'Movie Player'		'A Player for MPEG movies')"
	(FrameRateMorph		authoringPrototype			'Frame Rate'		'An indicator of how fast your system is running')
	(MagnifierMorph		newRound					'Magnifier'			'A magnifying glass')
	(ScriptingSystem		newScriptingSpace			'Scripting'			'A confined place for drawing and scripting, with its own private stop/step/go buttons.')
	(ScriptingSystem		holderWithAlphabet			'Alphabet'			'A source for single-letter objects')
	(BouncingAtomsMorph	new						'Bouncing Atoms'	'Atoms, mate')
	(ObjectsTool				newStandAlone				'Object Catalog'		'A tool that lets you browse the catalog of objects')
	) asOrderedCollection! !


!MCFileRepositoryInspector methodsFor: 'as yet unclassified' stamp: 'rej 2/21/2007 21:08'!
refresh
	| packageNames name latest av |
	packageNames := Set new.
	versions := repository readableFileNames collect: [ :each |
		name := (each copyUpToLast: $.) copyUpTo: $(.
		name last isDigit ifFalse: [Array with: name with: '' with: '' with: each]
			ifTrue:
				[Array
					with: (packageNames add: (name copyUpToLast:  $-))		"pkg name"
					with: ((name copyAfterLast: $-) copyUpTo: $.)				"user"
					with: ((name copyAfterLast: $-) copyAfter: $.) asInteger	"version"
					with: each]].
	versions := versions select: [:each | (each at: 3) isNumber].
	newer := Set new.
	inherited := Set new.
	loaded := Set new.
	(MCWorkingCopy allManagers 
"		select: [ :each | packageNames includes: each packageName]")
		do: [:each |
			each ancestors do: [ :ancestor |
				loaded add: ancestor name.
				ancestor ancestorsDoWhileTrue: [:heir |
					(inherited includes: heir name)
						ifTrue: [false]
						ifFalse: [inherited add: heir name. true]]].
			latest := (versions select: [:v | v first = each package name])	
				detectMax: [:v | v third].
			(latest notNil and: [
				each ancestors allSatisfy: [:ancestor |
					av := ((ancestor name copyAfterLast: $-) copyAfter: $.) asInteger.
					av < latest third or: [
						av = latest third and: [((ancestor name copyAfterLast: $-) copyUpTo: $.) ~= latest second]]]])
				ifTrue: [newer add: each package name ]].

	self changed: #packageList; changed: #versionList! !

"Load ReleaseBuilderFor3Dot10 and tell it to convert the image to 3.10"

| monti  version |
monti := MCHttpRepository
                location: 'http://source.squeakfoundation.org/310'
                user: ''
                password: ''.

 version := monti  loadVersionFromFileNamed: 'ReleaseBuilder-edc.29.mcz'.
version load.
version := monti  loadVersionFromFileNamed: 'Installer-Core-edc.85.mcz'.
version load.
ReleaseBuilderFor3dot10 new makeSqueakThreeTenRelease.!

